﻿using AjaxControlToolkit;
using System.Reflection;
using System.Resources;
using System.Runtime.CompilerServices;
using System.Runtime.InteropServices;
using System.Security;
using System.Web.UI;

[assembly: TagPrefix("AjaxControlToolkit", "ajaxToolkit")]
[assembly: AssemblyTitle("ASP.NET AJAX Control Toolkit")]

[assembly: AllowPartiallyTrustedCallers]
[assembly: ComVisible(false)]
[assembly: SecurityRules(SecurityRuleSet.Level1)]

[assembly: WebResource(Constants.AccordionName + Constants.DebugJsPostfix, "text/javascript", CdnPath = Constants.CdnScriptDebugPrefix + Constants.AccordionName + Constants.DebugJsPostfix, CdnSupportsSecureConnection = true)]
[assembly: WebResource(Constants.AccordionName + Constants.JsPostfix, "text/javascript", CdnPath = Constants.CdnScriptReleasePrefix + Constants.AccordionName + Constants.JsPostfix, CdnSupportsSecureConnection = true)]

[assembly: WebResource(Constants.AjaxFileUploadName + Constants.DebugJsPostfix, "text/javascript", CdnPath = Constants.CdnScriptDebugPrefix + Constants.AjaxFileUploadName + Constants.DebugJsPostfix, CdnSupportsSecureConnection = true)]
[assembly: WebResource(Constants.AjaxFileUploadName + Constants.JsPostfix, "text/javascript", CdnPath = Constants.CdnScriptReleasePrefix + Constants.AjaxFileUploadName + Constants.JsPostfix, CdnSupportsSecureConnection = true)]
[assembly: WebResource(Constants.StyleResourcePrefix + Constants.AjaxFileUploadName + Constants.CssPostfix, "text/css")]
[assembly: WebResource(Constants.StyleResourcePrefix + Constants.AjaxFileUploadName + Constants.MinCssPostfix, "text/css")]

[assembly: WebResource(Constants.AlwaysVisibleControlName + Constants.DebugJsPostfix, "text/javascript", CdnPath = Constants.CdnScriptDebugPrefix + Constants.AlwaysVisibleControlName + Constants.DebugJsPostfix, CdnSupportsSecureConnection = true)]
[assembly: WebResource(Constants.AlwaysVisibleControlName + Constants.JsPostfix, "text/javascript", CdnPath = Constants.CdnScriptReleasePrefix + Constants.AlwaysVisibleControlName + Constants.JsPostfix, CdnSupportsSecureConnection = true)]

[assembly: WebResource(Constants.AnimationName + Constants.DebugJsPostfix, "text/javascript", CdnPath = Constants.CdnScriptDebugPrefix + Constants.AnimationName + Constants.DebugJsPostfix, CdnSupportsSecureConnection = true)]
[assembly: WebResource(Constants.AnimationName + Constants.JsPostfix, "text/javascript", CdnPath = Constants.CdnScriptReleasePrefix + Constants.AnimationName + Constants.JsPostfix, CdnSupportsSecureConnection = true)]

[assembly: WebResource(Constants.AnimationScriptsName + Constants.DebugJsPostfix, "text/javascript", CdnPath = Constants.CdnScriptDebugPrefix + Constants.AnimationScriptsName + Constants.DebugJsPostfix, CdnSupportsSecureConnection = true)]
[assembly: WebResource(Constants.AnimationScriptsName + Constants.JsPostfix, "text/javascript", CdnPath = Constants.CdnScriptReleasePrefix + Constants.AnimationScriptsName + Constants.JsPostfix, CdnSupportsSecureConnection = true)]

[assembly: WebResource(Constants.AsyncFileUploadName + Constants.DebugJsPostfix, "text/javascript", CdnPath = Constants.CdnScriptDebugPrefix + Constants.AsyncFileUploadName + Constants.DebugJsPostfix, CdnSupportsSecureConnection = true)]
[assembly: WebResource(Constants.AsyncFileUploadName + Constants.JsPostfix, "text/javascript", CdnPath = Constants.CdnScriptReleasePrefix + Constants.AsyncFileUploadName + Constants.JsPostfix, CdnSupportsSecureConnection = true)]
[assembly: WebResource(Constants.ImageResourcePrefix + Constants.AsyncFileUploadImage, "image/png")]

[assembly: WebResource(Constants.AreaChartName + Constants.DebugJsPostfix, "text/javascript", CdnPath = Constants.CdnScriptDebugPrefix + Constants.AreaChartName + Constants.DebugJsPostfix, CdnSupportsSecureConnection = true)]
[assembly: WebResource(Constants.AreaChartName + Constants.JsPostfix, "text/javascript", CdnPath = Constants.CdnScriptReleasePrefix + Constants.AreaChartName + Constants.JsPostfix, CdnSupportsSecureConnection = true)]
[assembly: WebResource(Constants.StyleResourcePrefix + Constants.AreaChartName + Constants.CssPostfix, "text/css")]
[assembly: WebResource(Constants.StyleResourcePrefix + Constants.AreaChartName + Constants.MinCssPostfix, "text/css")]

[assembly: WebResource(Constants.AutoCompleteName + Constants.DebugJsPostfix, "text/javascript", CdnPath = Constants.CdnScriptDebugPrefix + Constants.AutoCompleteName + Constants.DebugJsPostfix, CdnSupportsSecureConnection = true)]
[assembly: WebResource(Constants.AutoCompleteName + Constants.JsPostfix, "text/javascript", CdnPath = Constants.CdnScriptReleasePrefix + Constants.AutoCompleteName + Constants.JsPostfix, CdnSupportsSecureConnection = true)]

[assembly: WebResource(Constants.StyleResourcePrefix + Constants.BackgroundStylesName + Constants.CssPostfix, "text/css", PerformSubstitution = true)]
[assembly: WebResource(Constants.StyleResourcePrefix + Constants.BackgroundStylesName + Constants.MinCssPostfix, "text/css", PerformSubstitution = true)]

[assembly: WebResource(Constants.BaseScriptName + Constants.DebugJsPostfix, "text/javascript", CdnPath = Constants.CdnScriptDebugPrefix + Constants.BaseScriptName + Constants.DebugJsPostfix, CdnSupportsSecureConnection = true)]
[assembly: WebResource(Constants.BaseScriptName + Constants.JsPostfix, "text/javascript", CdnPath = Constants.CdnScriptReleasePrefix + Constants.BaseScriptName + Constants.JsPostfix, CdnSupportsSecureConnection = true)]

[assembly: WebResource(Constants.BalloonPopupName + Constants.DebugJsPostfix, "text/javascript", CdnPath = Constants.CdnScriptDebugPrefix + Constants.BalloonPopupName + Constants.DebugJsPostfix, CdnSupportsSecureConnection = true)]
[assembly: WebResource(Constants.BalloonPopupName + Constants.JsPostfix, "text/javascript", CdnPath = Constants.CdnScriptReleasePrefix + Constants.BalloonPopupName + Constants.JsPostfix, CdnSupportsSecureConnection = true)]
[assembly: WebResource(Constants.StyleResourcePrefix + Constants.BalloonPopupName + ".Cloud" + Constants.CssPostfix, "text/css", PerformSubstitution = true)]
[assembly: WebResource(Constants.StyleResourcePrefix + Constants.BalloonPopupName + ".Cloud" + Constants.MinCssPostfix, "text/css", PerformSubstitution = true)]
[assembly: WebResource(Constants.StyleResourcePrefix + Constants.BalloonPopupName + ".Rectangle" + Constants.CssPostfix, "text/css", PerformSubstitution = true)]
[assembly: WebResource(Constants.StyleResourcePrefix + Constants.BalloonPopupName + ".Rectangle" + Constants.MinCssPostfix, "text/css", PerformSubstitution = true)]
[assembly: WebResource(Constants.ImageResourcePrefix + Constants.BalloonPopupCloudPngSprite, "image/png")]
[assembly: WebResource(Constants.ImageResourcePrefix + Constants.BalloonPopupCloudGifSprite, "image/gif")]
[assembly: WebResource(Constants.ImageResourcePrefix + Constants.BalloonPopupRectanglePngSprite, "image/png")]
[assembly: WebResource(Constants.ImageResourcePrefix + Constants.BalloonPopupRectangleGifSprite, "image/gif")]

[assembly: WebResource(Constants.BarChartName + Constants.DebugJsPostfix, "text/javascript", CdnPath = Constants.CdnScriptDebugPrefix + Constants.BarChartName + Constants.DebugJsPostfix, CdnSupportsSecureConnection = true)]
[assembly: WebResource(Constants.BarChartName + Constants.JsPostfix, "text/javascript", CdnPath = Constants.CdnScriptReleasePrefix + Constants.BarChartName + Constants.JsPostfix, CdnSupportsSecureConnection = true)]
[assembly: WebResource(Constants.StyleResourcePrefix + Constants.BarChartName + Constants.CssPostfix, "text/css")]
[assembly: WebResource(Constants.StyleResourcePrefix + Constants.BarChartName + Constants.MinCssPostfix, "text/css")]

[assembly: WebResource(Constants.BubbleChartName + Constants.DebugJsPostfix, "text/javascript", CdnPath = Constants.CdnScriptDebugPrefix + Constants.BubbleChartName + Constants.DebugJsPostfix, CdnSupportsSecureConnection = true)]
[assembly: WebResource(Constants.BubbleChartName + Constants.JsPostfix, "text/javascript", CdnPath = Constants.CdnScriptReleasePrefix + Constants.BubbleChartName + Constants.JsPostfix, CdnSupportsSecureConnection = true)]
[assembly: WebResource(Constants.StyleResourcePrefix + Constants.BubbleChartName + Constants.CssPostfix, "text/css")]
[assembly: WebResource(Constants.StyleResourcePrefix + Constants.BubbleChartName + Constants.MinCssPostfix, "text/css")]

[assembly: WebResource(Constants.CommonScriptName + Constants.DebugJsPostfix, "text/javascript", CdnPath = Constants.CdnScriptDebugPrefix + Constants.CommonScriptName + Constants.DebugJsPostfix, CdnSupportsSecureConnection = true)]
[assembly: WebResource(Constants.CommonScriptName + Constants.JsPostfix, "text/javascript", CdnPath = Constants.CdnScriptReleasePrefix + Constants.CommonScriptName + Constants.JsPostfix, CdnSupportsSecureConnection = true)]

[assembly: WebResource(Constants.CompatDragDropScriptName + Constants.DebugJsPostfix, "text/javascript", CdnPath = Constants.CdnScriptDebugPrefix + Constants.CompatDragDropScriptName + Constants.DebugJsPostfix, CdnSupportsSecureConnection = true)]
[assembly: WebResource(Constants.CompatDragDropScriptName + Constants.JsPostfix, "text/javascript", CdnPath = Constants.CdnScriptReleasePrefix + Constants.CompatDragDropScriptName + Constants.JsPostfix, CdnSupportsSecureConnection = true)]

[assembly: WebResource(Constants.CompatTimerScriptName + Constants.DebugJsPostfix, "text/javascript", CdnPath = Constants.CdnScriptDebugPrefix + Constants.CompatTimerScriptName + Constants.DebugJsPostfix, CdnSupportsSecureConnection = true)]
[assembly: WebResource(Constants.CompatTimerScriptName + Constants.JsPostfix, "text/javascript", CdnPath = Constants.CdnScriptReleasePrefix + Constants.CompatTimerScriptName + Constants.JsPostfix, CdnSupportsSecureConnection = true)]

[assembly: WebResource(Constants.ComponentSetName + Constants.DebugJsPostfix, "text/javascript", CdnPath = Constants.CdnScriptDebugPrefix + Constants.ComponentSetName + Constants.DebugJsPostfix, CdnSupportsSecureConnection = true)]
[assembly: WebResource(Constants.ComponentSetName + Constants.JsPostfix, "text/javascript", CdnPath = Constants.CdnScriptReleasePrefix + Constants.ComponentSetName + Constants.JsPostfix, CdnSupportsSecureConnection = true)]

[assembly: WebResource(Constants.CalendarName + Constants.DebugJsPostfix, "text/javascript", CdnPath = Constants.CdnScriptDebugPrefix + Constants.CalendarName + Constants.DebugJsPostfix, CdnSupportsSecureConnection = true)]
[assembly: WebResource(Constants.CalendarName + Constants.JsPostfix, "text/javascript", CdnPath = Constants.CdnScriptReleasePrefix + Constants.CalendarName + Constants.JsPostfix, CdnSupportsSecureConnection = true)]
[assembly: WebResource(Constants.StyleResourcePrefix + Constants.CalendarName + Constants.CssPostfix, "text/css", PerformSubstitution = true)]
[assembly: WebResource(Constants.StyleResourcePrefix + Constants.CalendarName + Constants.MinCssPostfix, "text/css", PerformSubstitution = true)]
[assembly: WebResource(Constants.ImageResourcePrefix + Constants.CalendarArrowLeftImage, "image/gif")]
[assembly: WebResource(Constants.ImageResourcePrefix + Constants.CalendarArrowRightImage, "image/gif")]

[assembly: WebResource(Constants.CascadingDropDownName + Constants.DebugJsPostfix, "text/javascript", CdnPath = Constants.CdnScriptDebugPrefix + Constants.CascadingDropDownName + Constants.DebugJsPostfix, CdnSupportsSecureConnection = true)]
[assembly: WebResource(Constants.CascadingDropDownName + Constants.JsPostfix, "text/javascript", CdnPath = Constants.CdnScriptReleasePrefix + Constants.CascadingDropDownName + Constants.JsPostfix, CdnSupportsSecureConnection = true)]

[assembly: WebResource(Constants.CollapsiblePanelName + Constants.DebugJsPostfix, "text/javascript", CdnPath = Constants.CdnScriptDebugPrefix + Constants.CollapsiblePanelName + Constants.DebugJsPostfix, CdnSupportsSecureConnection = true)]
[assembly: WebResource(Constants.CollapsiblePanelName + Constants.JsPostfix, "text/javascript", CdnPath = Constants.CdnScriptReleasePrefix + Constants.CollapsiblePanelName + Constants.JsPostfix, CdnSupportsSecureConnection = true)]

[assembly: WebResource(Constants.ColorPickerName + Constants.DebugJsPostfix, "text/javascript", CdnPath = Constants.CdnScriptDebugPrefix + Constants.ColorPickerName + Constants.DebugJsPostfix, CdnSupportsSecureConnection = true)]
[assembly: WebResource(Constants.ColorPickerName + Constants.JsPostfix, "text/javascript", CdnPath = Constants.CdnScriptReleasePrefix + Constants.ColorPickerName + Constants.JsPostfix, CdnSupportsSecureConnection = true)]
[assembly: WebResource(Constants.StyleResourcePrefix + Constants.ColorPickerName + Constants.CssPostfix, "text/css", PerformSubstitution = true)]
[assembly: WebResource(Constants.StyleResourcePrefix + Constants.ColorPickerName + Constants.MinCssPostfix, "text/css", PerformSubstitution = true)]

[assembly: WebResource(Constants.ComboBoxName + Constants.DebugJsPostfix, "text/javascript", CdnPath = Constants.CdnScriptDebugPrefix + Constants.ComboBoxName + Constants.DebugJsPostfix, CdnSupportsSecureConnection = true)]
[assembly: WebResource(Constants.ComboBoxName + Constants.JsPostfix, "text/javascript", CdnPath = Constants.CdnScriptReleasePrefix + Constants.ComboBoxName + Constants.JsPostfix, CdnSupportsSecureConnection = true)]
[assembly: WebResource(Constants.StyleResourcePrefix + Constants.ComboBoxName + Constants.CssPostfix, "text/css", PerformSubstitution = true)]
[assembly: WebResource(Constants.StyleResourcePrefix + Constants.ComboBoxName + Constants.MinCssPostfix, "text/css", PerformSubstitution = true)]
[assembly: WebResource(Constants.ImageResourcePrefix + Constants.ComboBoxArrowDownImage, "image/gif")]

[assembly: WebResource(Constants.ConfirmButtonName + Constants.DebugJsPostfix, "text/javascript", CdnPath = Constants.CdnScriptDebugPrefix + Constants.ConfirmButtonName + Constants.DebugJsPostfix, CdnSupportsSecureConnection = true)]
[assembly: WebResource(Constants.ConfirmButtonName + Constants.JsPostfix, "text/javascript", CdnPath = Constants.CdnScriptReleasePrefix + Constants.ConfirmButtonName + Constants.JsPostfix, CdnSupportsSecureConnection = true)]

[assembly: WebResource(Constants.DateTimeScriptName + Constants.DebugJsPostfix, "text/javascript", CdnPath = Constants.CdnScriptDebugPrefix + Constants.DateTimeScriptName + Constants.DebugJsPostfix, CdnSupportsSecureConnection = true)]
[assembly: WebResource(Constants.DateTimeScriptName + Constants.JsPostfix, "text/javascript", CdnPath = Constants.CdnScriptReleasePrefix + Constants.DateTimeScriptName + Constants.JsPostfix, CdnSupportsSecureConnection = true)]

[assembly: WebResource(Constants.DynamicPopulateName + Constants.DebugJsPostfix, "text/javascript", CdnPath = Constants.CdnScriptDebugPrefix + Constants.DynamicPopulateName + Constants.DebugJsPostfix, CdnSupportsSecureConnection = true)]
[assembly: WebResource(Constants.DynamicPopulateName + Constants.JsPostfix, "text/javascript", CdnPath = Constants.CdnScriptReleasePrefix + Constants.DynamicPopulateName + Constants.JsPostfix, CdnSupportsSecureConnection = true)]

[assembly: WebResource(Constants.DraggableListItemName + Constants.DebugJsPostfix, "text/javascript", CdnPath = Constants.CdnScriptDebugPrefix + Constants.DraggableListItemName + Constants.DebugJsPostfix, CdnSupportsSecureConnection = true)]
[assembly: WebResource(Constants.DraggableListItemName + Constants.JsPostfix, "text/javascript", CdnPath = Constants.CdnScriptReleasePrefix + Constants.DraggableListItemName + Constants.JsPostfix, CdnSupportsSecureConnection = true)]

[assembly: WebResource(Constants.DropDownName + Constants.DebugJsPostfix, "text/javascript", CdnPath = Constants.CdnScriptDebugPrefix + Constants.DropDownName + Constants.DebugJsPostfix, CdnSupportsSecureConnection = true)]
[assembly: WebResource(Constants.DropDownName + Constants.JsPostfix, "text/javascript", CdnPath = Constants.CdnScriptReleasePrefix + Constants.DropDownName + Constants.JsPostfix, CdnSupportsSecureConnection = true)]
[assembly: WebResource(Constants.StyleResourcePrefix + Constants.DropDownName + Constants.CssPostfix, "text/css", PerformSubstitution = true)]
[assembly: WebResource(Constants.StyleResourcePrefix + Constants.DropDownName + Constants.MinCssPostfix, "text/css", PerformSubstitution = true)]
[assembly: WebResource(Constants.ImageResourcePrefix + Constants.DropDownDropArrowImage, "image/gif")]

[assembly: WebResource(Constants.DropShadowName + Constants.DebugJsPostfix, "text/javascript", CdnPath = Constants.CdnScriptDebugPrefix + Constants.DropShadowName + Constants.DebugJsPostfix, CdnSupportsSecureConnection = true)]
[assembly: WebResource(Constants.DropShadowName + Constants.JsPostfix, "text/javascript", CdnPath = Constants.CdnScriptReleasePrefix + Constants.DropShadowName + Constants.JsPostfix, CdnSupportsSecureConnection = true)]

[assembly: WebResource(Constants.DropWatcherName + Constants.DebugJsPostfix, "text/javascript", CdnPath = Constants.CdnScriptDebugPrefix + Constants.DropWatcherName + Constants.DebugJsPostfix, CdnSupportsSecureConnection = true)]
[assembly: WebResource(Constants.DropWatcherName + Constants.JsPostfix, "text/javascript", CdnPath = Constants.CdnScriptReleasePrefix + Constants.DropWatcherName + Constants.JsPostfix, CdnSupportsSecureConnection = true)]

[assembly: WebResource(Constants.FilteredTextBoxName + Constants.DebugJsPostfix, "text/javascript", CdnPath = Constants.CdnScriptDebugPrefix + Constants.FilteredTextBoxName + Constants.DebugJsPostfix, CdnSupportsSecureConnection = true)]
[assembly: WebResource(Constants.FilteredTextBoxName + Constants.JsPostfix, "text/javascript", CdnPath = Constants.CdnScriptReleasePrefix + Constants.FilteredTextBoxName + Constants.JsPostfix, CdnSupportsSecureConnection = true)]

[assembly: WebResource(Constants.FloatingBehaviorName + Constants.DebugJsPostfix, "text/javascript", CdnPath = Constants.CdnScriptDebugPrefix + Constants.FloatingBehaviorName + Constants.DebugJsPostfix, CdnSupportsSecureConnection = true)]
[assembly: WebResource(Constants.FloatingBehaviorName + Constants.JsPostfix, "text/javascript", CdnPath = Constants.CdnScriptReleasePrefix + Constants.FloatingBehaviorName + Constants.JsPostfix, CdnSupportsSecureConnection = true)]

[assembly: WebResource(Constants.ImageResourcePrefix + Constants.GravatarAnonymousImage, "image/jpeg")]
[assembly: WebResource(Constants.ImageResourcePrefix + Constants.GravatarGImage, "image/jpeg")]
[assembly: WebResource(Constants.ImageResourcePrefix + Constants.GravatarPGImage, "image/jpeg")]
[assembly: WebResource(Constants.ImageResourcePrefix + Constants.GravatarRImage, "image/jpeg")]
[assembly: WebResource(Constants.ImageResourcePrefix + Constants.GravatarXImage, "image/jpeg")]

[assembly: WebResource(Constants.HoverMenuName + Constants.DebugJsPostfix, "text/javascript", CdnPath = Constants.CdnScriptDebugPrefix + Constants.HoverMenuName + Constants.DebugJsPostfix, CdnSupportsSecureConnection = true)]
[assembly: WebResource(Constants.HoverMenuName + Constants.JsPostfix, "text/javascript", CdnPath = Constants.CdnScriptReleasePrefix + Constants.HoverMenuName + Constants.JsPostfix, CdnSupportsSecureConnection = true)]

[assembly: WebResource(Constants.HoverName + Constants.DebugJsPostfix, "text/javascript", CdnPath = Constants.CdnScriptDebugPrefix + Constants.HoverName + Constants.DebugJsPostfix, CdnSupportsSecureConnection = true)]
[assembly: WebResource(Constants.HoverName + Constants.JsPostfix, "text/javascript", CdnPath = Constants.CdnScriptReleasePrefix + Constants.HoverName + Constants.JsPostfix, CdnSupportsSecureConnection = true)]

[assembly: WebResource(Constants.HtmlEditorExtenderName + Constants.DebugJsPostfix, "text/javascript", CdnPath = Constants.CdnScriptDebugPrefix + Constants.HtmlEditorExtenderName + Constants.DebugJsPostfix, CdnSupportsSecureConnection = true)]
[assembly: WebResource(Constants.HtmlEditorExtenderName + Constants.JsPostfix, "text/javascript", CdnPath = Constants.CdnScriptReleasePrefix + Constants.HtmlEditorExtenderName + Constants.JsPostfix, CdnSupportsSecureConnection = true)]
[assembly: WebResource(Constants.StyleResourcePrefix + Constants.HtmlEditorExtenderName + Constants.CssPostfix, "text/css")]
[assembly: WebResource(Constants.StyleResourcePrefix + Constants.HtmlEditorExtenderName + Constants.MinCssPostfix, "text/css")]
[assembly: WebResource(Constants.ImageResourcePrefix + Constants.HtmlEditorExtenderName, "image/png")]

[assembly: WebResource(Constants.HtmlEditorEditorName + Constants.DebugJsPostfix, "text/javascript", CdnPath = Constants.CdnScriptDebugPrefix + Constants.HtmlEditorEditorName + Constants.DebugJsPostfix, CdnSupportsSecureConnection = true)]
[assembly: WebResource(Constants.HtmlEditorEditorName + Constants.JsPostfix, "text/javascript", CdnPath = Constants.CdnScriptReleasePrefix + Constants.HtmlEditorEditorName + Constants.JsPostfix, CdnSupportsSecureConnection = true)]
[assembly: WebResource(Constants.HtmlEditorHtmlEditorName + Constants.DebugJsPostfix, "text/javascript", CdnPath = Constants.CdnScriptDebugPrefix + Constants.HtmlEditorHtmlEditorName + Constants.DebugJsPostfix, CdnSupportsSecureConnection = true)]
[assembly: WebResource(Constants.HtmlEditorHtmlEditorName + Constants.JsPostfix, "text/javascript", CdnPath = Constants.CdnScriptReleasePrefix + Constants.HtmlEditorHtmlEditorName + Constants.JsPostfix, CdnSupportsSecureConnection = true)]
[assembly: WebResource(Constants.HtmlEditorEnumsName + Constants.DebugJsPostfix, "text/javascript", CdnPath = Constants.CdnScriptDebugPrefix + Constants.HtmlEditorEnumsName + Constants.DebugJsPostfix, CdnSupportsSecureConnection = true)]
[assembly: WebResource(Constants.HtmlEditorEnumsName + Constants.JsPostfix, "text/javascript", CdnPath = Constants.CdnScriptReleasePrefix + Constants.HtmlEditorEnumsName + Constants.JsPostfix, CdnSupportsSecureConnection = true)]
[assembly: WebResource(Constants.HtmlEditorEventsName + Constants.DebugJsPostfix, "text/javascript", CdnPath = Constants.CdnScriptDebugPrefix + Constants.HtmlEditorEventsName + Constants.DebugJsPostfix, CdnSupportsSecureConnection = true)]
[assembly: WebResource(Constants.HtmlEditorEventsName + Constants.JsPostfix, "text/javascript", CdnPath = Constants.CdnScriptReleasePrefix + Constants.HtmlEditorEventsName + Constants.JsPostfix, CdnSupportsSecureConnection = true)]
[assembly: WebResource(Constants.HtmlEditorPreviewPanelName + Constants.DebugJsPostfix, "text/javascript", CdnPath = Constants.CdnScriptDebugPrefix + Constants.HtmlEditorPreviewPanelName + Constants.DebugJsPostfix, CdnSupportsSecureConnection = true)]
[assembly: WebResource(Constants.HtmlEditorPreviewPanelName + Constants.JsPostfix, "text/javascript", CdnPath = Constants.CdnScriptReleasePrefix + Constants.HtmlEditorPreviewPanelName + Constants.JsPostfix, CdnSupportsSecureConnection = true)]
[assembly: WebResource(Constants.HtmlEditorModePanelName + Constants.DebugJsPostfix, "text/javascript", CdnPath = Constants.CdnScriptDebugPrefix + Constants.HtmlEditorModePanelName + Constants.DebugJsPostfix, CdnSupportsSecureConnection = true)]
[assembly: WebResource(Constants.HtmlEditorModePanelName + Constants.JsPostfix, "text/javascript", CdnPath = Constants.CdnScriptReleasePrefix + Constants.HtmlEditorModePanelName + Constants.JsPostfix, CdnSupportsSecureConnection = true)]
[assembly: WebResource(Constants.HtmlEditorEditPanelName + Constants.DebugJsPostfix, "text/javascript", CdnPath = Constants.CdnScriptDebugPrefix + Constants.HtmlEditorEditPanelName + Constants.DebugJsPostfix, CdnSupportsSecureConnection = true)]
[assembly: WebResource(Constants.HtmlEditorEditPanelName + Constants.JsPostfix, "text/javascript", CdnPath = Constants.CdnScriptReleasePrefix + Constants.HtmlEditorEditPanelName + Constants.JsPostfix, CdnSupportsSecureConnection = true)]
[assembly: WebResource(Constants.HtmlEditorHtmlPanelName + Constants.DebugJsPostfix, "text/javascript", CdnPath = Constants.CdnScriptDebugPrefix + Constants.HtmlEditorHtmlPanelName + Constants.DebugJsPostfix, CdnSupportsSecureConnection = true)]
[assembly: WebResource(Constants.HtmlEditorHtmlPanelName + Constants.JsPostfix, "text/javascript", CdnPath = Constants.CdnScriptReleasePrefix + Constants.HtmlEditorHtmlPanelName + Constants.JsPostfix, CdnSupportsSecureConnection = true)]
[assembly: WebResource(Constants.HtmlEditorExecCommandEmulationName + Constants.DebugJsPostfix, "text/javascript", CdnPath = Constants.CdnScriptDebugPrefix + Constants.HtmlEditorExecCommandEmulationName + Constants.DebugJsPostfix, CdnSupportsSecureConnection = true)]
[assembly: WebResource(Constants.HtmlEditorExecCommandEmulationName + Constants.JsPostfix, "text/javascript", CdnPath = Constants.CdnScriptReleasePrefix + Constants.HtmlEditorExecCommandEmulationName + Constants.JsPostfix, CdnSupportsSecureConnection = true)]
[assembly: WebResource(Constants.HtmlEditorDesignPanelName + Constants.DebugJsPostfix, "text/javascript", CdnPath = Constants.CdnScriptDebugPrefix + Constants.HtmlEditorDesignPanelName + Constants.DebugJsPostfix, CdnSupportsSecureConnection = true)]
[assembly: WebResource(Constants.HtmlEditorDesignPanelName + Constants.JsPostfix, "text/javascript", CdnPath = Constants.CdnScriptReleasePrefix + Constants.HtmlEditorDesignPanelName + Constants.JsPostfix, CdnSupportsSecureConnection = true)]
[assembly: WebResource(Constants.HtmlEditorDesignPanelEventHandlerName + Constants.DebugJsPostfix, "text/javascript", CdnPath = Constants.CdnScriptDebugPrefix + Constants.HtmlEditorDesignPanelEventHandlerName + Constants.DebugJsPostfix, CdnSupportsSecureConnection = true)]
[assembly: WebResource(Constants.HtmlEditorDesignPanelEventHandlerName + Constants.JsPostfix, "text/javascript", CdnPath = Constants.CdnScriptReleasePrefix + Constants.HtmlEditorDesignPanelEventHandlerName + Constants.JsPostfix, CdnSupportsSecureConnection = true)]

[assembly: WebResource(Constants.HtmlEditorPopupName + Constants.DebugJsPostfix, "text/javascript", CdnPath = Constants.CdnScriptDebugPrefix + Constants.HtmlEditorPopupName + Constants.DebugJsPostfix, CdnSupportsSecureConnection = true)]
[assembly: WebResource(Constants.HtmlEditorPopupName + Constants.JsPostfix, "text/javascript", CdnPath = Constants.CdnScriptReleasePrefix + Constants.HtmlEditorPopupName + Constants.JsPostfix, CdnSupportsSecureConnection = true)]
[assembly: WebResource(Constants.HtmlEditorAttachedTemplatePopupName + Constants.DebugJsPostfix, "text/javascript", CdnPath = Constants.CdnScriptDebugPrefix + Constants.HtmlEditorAttachedTemplatePopupName + Constants.DebugJsPostfix, CdnSupportsSecureConnection = true)]
[assembly: WebResource(Constants.HtmlEditorAttachedTemplatePopupName + Constants.JsPostfix, "text/javascript", CdnPath = Constants.CdnScriptReleasePrefix + Constants.HtmlEditorAttachedTemplatePopupName + Constants.JsPostfix, CdnSupportsSecureConnection = true)]
[assembly: WebResource(Constants.HtmlEditorAttachedPopupName + Constants.DebugJsPostfix, "text/javascript", CdnPath = Constants.CdnScriptDebugPrefix + Constants.HtmlEditorAttachedPopupName + Constants.DebugJsPostfix, CdnSupportsSecureConnection = true)]
[assembly: WebResource(Constants.HtmlEditorAttachedPopupName + Constants.JsPostfix, "text/javascript", CdnPath = Constants.CdnScriptReleasePrefix + Constants.HtmlEditorAttachedPopupName + Constants.JsPostfix, CdnSupportsSecureConnection = true)]
[assembly: WebResource(Constants.HtmlEditorPopupCommandButtonName + Constants.DebugJsPostfix, "text/javascript", CdnPath = Constants.CdnScriptDebugPrefix + Constants.HtmlEditorPopupCommandButtonName + Constants.DebugJsPostfix, CdnSupportsSecureConnection = true)]
[assembly: WebResource(Constants.HtmlEditorPopupCommandButtonName + Constants.JsPostfix, "text/javascript", CdnPath = Constants.CdnScriptReleasePrefix + Constants.HtmlEditorPopupCommandButtonName + Constants.JsPostfix, CdnSupportsSecureConnection = true)]
[assembly: WebResource(Constants.HtmlEditorPopupBoxButtonName + Constants.DebugJsPostfix, "text/javascript", CdnPath = Constants.CdnScriptDebugPrefix + Constants.HtmlEditorPopupBoxButtonName + Constants.DebugJsPostfix, CdnSupportsSecureConnection = true)]
[assembly: WebResource(Constants.HtmlEditorPopupBoxButtonName + Constants.JsPostfix, "text/javascript", CdnPath = Constants.CdnScriptReleasePrefix + Constants.HtmlEditorPopupBoxButtonName + Constants.JsPostfix, CdnSupportsSecureConnection = true)]
[assembly: WebResource(Constants.HtmlEditorPopupBGIButtonName + Constants.DebugJsPostfix, "text/javascript", CdnPath = Constants.CdnScriptDebugPrefix + Constants.HtmlEditorPopupBGIButtonName + Constants.DebugJsPostfix, CdnSupportsSecureConnection = true)]
[assembly: WebResource(Constants.HtmlEditorPopupBGIButtonName + Constants.JsPostfix, "text/javascript", CdnPath = Constants.CdnScriptReleasePrefix + Constants.HtmlEditorPopupBGIButtonName + Constants.JsPostfix, CdnSupportsSecureConnection = true)]
[assembly: WebResource(Constants.HtmlEditorOkCancelAttachedTemplatePopupName + Constants.DebugJsPostfix, "text/javascript", CdnPath = Constants.CdnScriptDebugPrefix + Constants.HtmlEditorOkCancelAttachedTemplatePopupName + Constants.DebugJsPostfix, CdnSupportsSecureConnection = true)]
[assembly: WebResource(Constants.HtmlEditorOkCancelAttachedTemplatePopupName + Constants.JsPostfix, "text/javascript", CdnPath = Constants.CdnScriptReleasePrefix + Constants.HtmlEditorOkCancelAttachedTemplatePopupName + Constants.JsPostfix, CdnSupportsSecureConnection = true)]
[assembly: WebResource(Constants.HtmlEditorLinkPropertiesName + Constants.DebugJsPostfix, "text/javascript", CdnPath = Constants.CdnScriptDebugPrefix + Constants.HtmlEditorLinkPropertiesName + Constants.DebugJsPostfix, CdnSupportsSecureConnection = true)]
[assembly: WebResource(Constants.HtmlEditorLinkPropertiesName + Constants.JsPostfix, "text/javascript", CdnPath = Constants.CdnScriptReleasePrefix + Constants.HtmlEditorLinkPropertiesName + Constants.JsPostfix, CdnSupportsSecureConnection = true)]
[assembly: WebResource(Constants.HtmlEditorBaseColorsPopupName + Constants.DebugJsPostfix, "text/javascript", CdnPath = Constants.CdnScriptDebugPrefix + Constants.HtmlEditorBaseColorsPopupName + Constants.DebugJsPostfix, CdnSupportsSecureConnection = true)]
[assembly: WebResource(Constants.HtmlEditorBaseColorsPopupName + Constants.JsPostfix, "text/javascript", CdnPath = Constants.CdnScriptReleasePrefix + Constants.HtmlEditorBaseColorsPopupName + Constants.JsPostfix, CdnSupportsSecureConnection = true)]

[assembly: WebResource(Constants.HtmlEditorBackColorClearButtonName + Constants.DebugJsPostfix, "text/javascript", CdnPath = Constants.CdnScriptDebugPrefix + Constants.HtmlEditorBackColorClearButtonName + Constants.DebugJsPostfix, CdnSupportsSecureConnection = true)]
[assembly: WebResource(Constants.HtmlEditorBackColorClearButtonName + Constants.JsPostfix, "text/javascript", CdnPath = Constants.CdnScriptReleasePrefix + Constants.HtmlEditorBackColorClearButtonName + Constants.JsPostfix, CdnSupportsSecureConnection = true)]
[assembly: WebResource(Constants.HtmlEditorBackColorSelectorButtonName + Constants.DebugJsPostfix, "text/javascript", CdnPath = Constants.CdnScriptDebugPrefix + Constants.HtmlEditorBackColorSelectorButtonName + Constants.DebugJsPostfix, CdnSupportsSecureConnection = true)]
[assembly: WebResource(Constants.HtmlEditorBackColorSelectorButtonName + Constants.JsPostfix, "text/javascript", CdnPath = Constants.CdnScriptReleasePrefix + Constants.HtmlEditorBackColorSelectorButtonName + Constants.JsPostfix, CdnSupportsSecureConnection = true)]
[assembly: WebResource(Constants.HtmlEditorBoldButtonName + Constants.DebugJsPostfix, "text/javascript", CdnPath = Constants.CdnScriptDebugPrefix + Constants.HtmlEditorBoldButtonName + Constants.DebugJsPostfix, CdnSupportsSecureConnection = true)]
[assembly: WebResource(Constants.HtmlEditorBoldButtonName + Constants.JsPostfix, "text/javascript", CdnPath = Constants.CdnScriptReleasePrefix + Constants.HtmlEditorBoldButtonName + Constants.JsPostfix, CdnSupportsSecureConnection = true)]
[assembly: WebResource(Constants.HtmlEditorBoxButtonName + Constants.DebugJsPostfix, "text/javascript", CdnPath = Constants.CdnScriptDebugPrefix + Constants.HtmlEditorBoxButtonName + Constants.DebugJsPostfix, CdnSupportsSecureConnection = true)]
[assembly: WebResource(Constants.HtmlEditorBoxButtonName + Constants.JsPostfix, "text/javascript", CdnPath = Constants.CdnScriptReleasePrefix + Constants.HtmlEditorBoxButtonName + Constants.JsPostfix, CdnSupportsSecureConnection = true)]
[assembly: WebResource(Constants.HtmlEditorBulletedListButtonName + Constants.DebugJsPostfix, "text/javascript", CdnPath = Constants.CdnScriptDebugPrefix + Constants.HtmlEditorBulletedListButtonName + Constants.DebugJsPostfix, CdnSupportsSecureConnection = true)]
[assembly: WebResource(Constants.HtmlEditorBulletedListButtonName + Constants.JsPostfix, "text/javascript", CdnPath = Constants.CdnScriptReleasePrefix + Constants.HtmlEditorBulletedListButtonName + Constants.JsPostfix, CdnSupportsSecureConnection = true)]
[assembly: WebResource(Constants.HtmlEditorColorButtonName + Constants.DebugJsPostfix, "text/javascript", CdnPath = Constants.CdnScriptDebugPrefix + Constants.HtmlEditorColorButtonName + Constants.DebugJsPostfix, CdnSupportsSecureConnection = true)]
[assembly: WebResource(Constants.HtmlEditorColorButtonName + Constants.JsPostfix, "text/javascript", CdnPath = Constants.CdnScriptReleasePrefix + Constants.HtmlEditorColorButtonName + Constants.JsPostfix, CdnSupportsSecureConnection = true)]
[assembly: WebResource(Constants.HtmlEditorColorSelectorName + Constants.DebugJsPostfix, "text/javascript", CdnPath = Constants.CdnScriptDebugPrefix + Constants.HtmlEditorColorSelectorName + Constants.DebugJsPostfix, CdnSupportsSecureConnection = true)]
[assembly: WebResource(Constants.HtmlEditorColorSelectorName + Constants.JsPostfix, "text/javascript", CdnPath = Constants.CdnScriptReleasePrefix + Constants.HtmlEditorColorSelectorName + Constants.JsPostfix, CdnSupportsSecureConnection = true)]
[assembly: WebResource(Constants.HtmlEditorCommonButtonName + Constants.DebugJsPostfix, "text/javascript", CdnPath = Constants.CdnScriptDebugPrefix + Constants.HtmlEditorCommonButtonName + Constants.DebugJsPostfix, CdnSupportsSecureConnection = true)]
[assembly: WebResource(Constants.HtmlEditorCommonButtonName + Constants.JsPostfix, "text/javascript", CdnPath = Constants.CdnScriptReleasePrefix + Constants.HtmlEditorCommonButtonName + Constants.JsPostfix, CdnSupportsSecureConnection = true)]
[assembly: WebResource(Constants.HtmlEditorCopyButtonName + Constants.DebugJsPostfix, "text/javascript", CdnPath = Constants.CdnScriptDebugPrefix + Constants.HtmlEditorCopyButtonName + Constants.DebugJsPostfix, CdnSupportsSecureConnection = true)]
[assembly: WebResource(Constants.HtmlEditorCopyButtonName + Constants.JsPostfix, "text/javascript", CdnPath = Constants.CdnScriptReleasePrefix + Constants.HtmlEditorCopyButtonName + Constants.JsPostfix, CdnSupportsSecureConnection = true)]
[assembly: WebResource(Constants.HtmlEditorCutButtonName + Constants.DebugJsPostfix, "text/javascript", CdnPath = Constants.CdnScriptDebugPrefix + Constants.HtmlEditorCutButtonName + Constants.DebugJsPostfix, CdnSupportsSecureConnection = true)]
[assembly: WebResource(Constants.HtmlEditorCutButtonName + Constants.JsPostfix, "text/javascript", CdnPath = Constants.CdnScriptReleasePrefix + Constants.HtmlEditorCutButtonName + Constants.JsPostfix, CdnSupportsSecureConnection = true)]
[assembly: WebResource(Constants.HtmlEditorDecreaseIndentButtonName + Constants.DebugJsPostfix, "text/javascript", CdnPath = Constants.CdnScriptDebugPrefix + Constants.HtmlEditorDecreaseIndentButtonName + Constants.DebugJsPostfix, CdnSupportsSecureConnection = true)]
[assembly: WebResource(Constants.HtmlEditorDecreaseIndentButtonName + Constants.JsPostfix, "text/javascript", CdnPath = Constants.CdnScriptReleasePrefix + Constants.HtmlEditorDecreaseIndentButtonName + Constants.JsPostfix, CdnSupportsSecureConnection = true)]
[assembly: WebResource(Constants.HtmlEditorDesignModeButtonName + Constants.DebugJsPostfix, "text/javascript", CdnPath = Constants.CdnScriptDebugPrefix + Constants.HtmlEditorDesignModeButtonName + Constants.DebugJsPostfix, CdnSupportsSecureConnection = true)]
[assembly: WebResource(Constants.HtmlEditorDesignModeButtonName + Constants.JsPostfix, "text/javascript", CdnPath = Constants.CdnScriptReleasePrefix + Constants.HtmlEditorDesignModeButtonName + Constants.JsPostfix, CdnSupportsSecureConnection = true)]
[assembly: WebResource(Constants.HtmlEditorDesignModeBoxButtonName + Constants.DebugJsPostfix, "text/javascript", CdnPath = Constants.CdnScriptDebugPrefix + Constants.HtmlEditorDesignModeBoxButtonName + Constants.DebugJsPostfix, CdnSupportsSecureConnection = true)]
[assembly: WebResource(Constants.HtmlEditorDesignModeBoxButtonName + Constants.JsPostfix, "text/javascript", CdnPath = Constants.CdnScriptReleasePrefix + Constants.HtmlEditorDesignModeBoxButtonName + Constants.JsPostfix, CdnSupportsSecureConnection = true)]
[assembly: WebResource(Constants.HtmlEditorDesignModeImageButtonName + Constants.DebugJsPostfix, "text/javascript", CdnPath = Constants.CdnScriptDebugPrefix + Constants.HtmlEditorDesignModeImageButtonName + Constants.DebugJsPostfix, CdnSupportsSecureConnection = true)]
[assembly: WebResource(Constants.HtmlEditorDesignModeImageButtonName + Constants.JsPostfix, "text/javascript", CdnPath = Constants.CdnScriptReleasePrefix + Constants.HtmlEditorDesignModeImageButtonName + Constants.JsPostfix, CdnSupportsSecureConnection = true)]
[assembly: WebResource(Constants.HtmlEditorDesignModePopupImageButtonName + Constants.DebugJsPostfix, "text/javascript", CdnPath = Constants.CdnScriptDebugPrefix + Constants.HtmlEditorDesignModePopupImageButtonName + Constants.DebugJsPostfix, CdnSupportsSecureConnection = true)]
[assembly: WebResource(Constants.HtmlEditorDesignModePopupImageButtonName + Constants.JsPostfix, "text/javascript", CdnPath = Constants.CdnScriptReleasePrefix + Constants.HtmlEditorDesignModePopupImageButtonName + Constants.JsPostfix, CdnSupportsSecureConnection = true)]
[assembly: WebResource(Constants.HtmlEditorDesignModeSelectButtonName + Constants.DebugJsPostfix, "text/javascript", CdnPath = Constants.CdnScriptDebugPrefix + Constants.HtmlEditorDesignModeSelectButtonName + Constants.DebugJsPostfix, CdnSupportsSecureConnection = true)]
[assembly: WebResource(Constants.HtmlEditorDesignModeSelectButtonName + Constants.JsPostfix, "text/javascript", CdnPath = Constants.CdnScriptReleasePrefix + Constants.HtmlEditorDesignModeSelectButtonName + Constants.JsPostfix, CdnSupportsSecureConnection = true)]
[assembly: WebResource(Constants.HtmlEditorToggleButtonName + Constants.DebugJsPostfix, "text/javascript", CdnPath = Constants.CdnScriptDebugPrefix + Constants.HtmlEditorToggleButtonName + Constants.DebugJsPostfix, CdnSupportsSecureConnection = true)]
[assembly: WebResource(Constants.HtmlEditorToggleButtonName + Constants.JsPostfix, "text/javascript", CdnPath = Constants.CdnScriptReleasePrefix + Constants.HtmlEditorToggleButtonName + Constants.JsPostfix, CdnSupportsSecureConnection = true)]
[assembly: WebResource(Constants.HtmlEditorFixedBackColorButtonName + Constants.DebugJsPostfix, "text/javascript", CdnPath = Constants.CdnScriptDebugPrefix + Constants.HtmlEditorFixedBackColorButtonName + Constants.DebugJsPostfix, CdnSupportsSecureConnection = true)]
[assembly: WebResource(Constants.HtmlEditorFixedBackColorButtonName + Constants.JsPostfix, "text/javascript", CdnPath = Constants.CdnScriptReleasePrefix + Constants.HtmlEditorFixedBackColorButtonName + Constants.JsPostfix, CdnSupportsSecureConnection = true)]
[assembly: WebResource(Constants.HtmlEditorFixedColorButtonName + Constants.DebugJsPostfix, "text/javascript", CdnPath = Constants.CdnScriptDebugPrefix + Constants.HtmlEditorFixedColorButtonName + Constants.DebugJsPostfix, CdnSupportsSecureConnection = true)]
[assembly: WebResource(Constants.HtmlEditorFixedColorButtonName + Constants.JsPostfix, "text/javascript", CdnPath = Constants.CdnScriptReleasePrefix + Constants.HtmlEditorFixedColorButtonName + Constants.JsPostfix, CdnSupportsSecureConnection = true)]
[assembly: WebResource(Constants.HtmlEditorFixedForeColorButtonName + Constants.DebugJsPostfix, "text/javascript", CdnPath = Constants.CdnScriptDebugPrefix + Constants.HtmlEditorFixedForeColorButtonName + Constants.DebugJsPostfix, CdnSupportsSecureConnection = true)]
[assembly: WebResource(Constants.HtmlEditorFixedForeColorButtonName + Constants.JsPostfix, "text/javascript", CdnPath = Constants.CdnScriptReleasePrefix + Constants.HtmlEditorFixedForeColorButtonName + Constants.JsPostfix, CdnSupportsSecureConnection = true)]
[assembly: WebResource(Constants.HtmlEditorFontNameButtonName + Constants.DebugJsPostfix, "text/javascript", CdnPath = Constants.CdnScriptDebugPrefix + Constants.HtmlEditorFontNameButtonName + Constants.DebugJsPostfix, CdnSupportsSecureConnection = true)]
[assembly: WebResource(Constants.HtmlEditorFontNameButtonName + Constants.JsPostfix, "text/javascript", CdnPath = Constants.CdnScriptReleasePrefix + Constants.HtmlEditorFontNameButtonName + Constants.JsPostfix, CdnSupportsSecureConnection = true)]
[assembly: WebResource(Constants.HtmlEditorFontSizeButtonName + Constants.DebugJsPostfix, "text/javascript", CdnPath = Constants.CdnScriptDebugPrefix + Constants.HtmlEditorFontSizeButtonName + Constants.DebugJsPostfix, CdnSupportsSecureConnection = true)]
[assembly: WebResource(Constants.HtmlEditorFontSizeButtonName + Constants.JsPostfix, "text/javascript", CdnPath = Constants.CdnScriptReleasePrefix + Constants.HtmlEditorFontSizeButtonName + Constants.JsPostfix, CdnSupportsSecureConnection = true)]
[assembly: WebResource(Constants.HtmlEditorForeColorButtonName + Constants.DebugJsPostfix, "text/javascript", CdnPath = Constants.CdnScriptDebugPrefix + Constants.HtmlEditorForeColorButtonName + Constants.DebugJsPostfix, CdnSupportsSecureConnection = true)]
[assembly: WebResource(Constants.HtmlEditorForeColorButtonName + Constants.JsPostfix, "text/javascript", CdnPath = Constants.CdnScriptReleasePrefix + Constants.HtmlEditorForeColorButtonName + Constants.JsPostfix, CdnSupportsSecureConnection = true)]
[assembly: WebResource(Constants.HtmlEditorForeColorClearButtonName + Constants.DebugJsPostfix, "text/javascript", CdnPath = Constants.CdnScriptDebugPrefix + Constants.HtmlEditorForeColorClearButtonName + Constants.DebugJsPostfix, CdnSupportsSecureConnection = true)]
[assembly: WebResource(Constants.HtmlEditorForeColorClearButtonName + Constants.JsPostfix, "text/javascript", CdnPath = Constants.CdnScriptReleasePrefix + Constants.HtmlEditorForeColorClearButtonName + Constants.JsPostfix, CdnSupportsSecureConnection = true)]
[assembly: WebResource(Constants.HtmlEditorForeColorSelectorButtonName + Constants.DebugJsPostfix, "text/javascript", CdnPath = Constants.CdnScriptDebugPrefix + Constants.HtmlEditorForeColorSelectorButtonName + Constants.DebugJsPostfix, CdnSupportsSecureConnection = true)]
[assembly: WebResource(Constants.HtmlEditorForeColorSelectorButtonName + Constants.JsPostfix, "text/javascript", CdnPath = Constants.CdnScriptReleasePrefix + Constants.HtmlEditorForeColorSelectorButtonName + Constants.JsPostfix, CdnSupportsSecureConnection = true)]
[assembly: WebResource(Constants.HtmlEditorHorizontalSepearatorButtonName + Constants.DebugJsPostfix, "text/javascript", CdnPath = Constants.CdnScriptDebugPrefix + Constants.HtmlEditorHorizontalSepearatorButtonName + Constants.DebugJsPostfix, CdnSupportsSecureConnection = true)]
[assembly: WebResource(Constants.HtmlEditorHorizontalSepearatorButtonName + Constants.JsPostfix, "text/javascript", CdnPath = Constants.CdnScriptReleasePrefix + Constants.HtmlEditorHorizontalSepearatorButtonName + Constants.JsPostfix, CdnSupportsSecureConnection = true)]
[assembly: WebResource(Constants.HtmlEditorItalicButtonName + Constants.DebugJsPostfix, "text/javascript", CdnPath = Constants.CdnScriptDebugPrefix + Constants.HtmlEditorItalicButtonName + Constants.DebugJsPostfix, CdnSupportsSecureConnection = true)]
[assembly: WebResource(Constants.HtmlEditorItalicButtonName + Constants.JsPostfix, "text/javascript", CdnPath = Constants.CdnScriptReleasePrefix + Constants.HtmlEditorItalicButtonName + Constants.JsPostfix, CdnSupportsSecureConnection = true)]
[assembly: WebResource(Constants.HtmlEditorModeButtonName + Constants.DebugJsPostfix, "text/javascript", CdnPath = Constants.CdnScriptDebugPrefix + Constants.HtmlEditorModeButtonName + Constants.DebugJsPostfix, CdnSupportsSecureConnection = true)]
[assembly: WebResource(Constants.HtmlEditorModeButtonName + Constants.JsPostfix, "text/javascript", CdnPath = Constants.CdnScriptReleasePrefix + Constants.HtmlEditorModeButtonName + Constants.JsPostfix, CdnSupportsSecureConnection = true)]
[assembly: WebResource(Constants.HtmlEditorHtmlModeButtonName + Constants.DebugJsPostfix, "text/javascript", CdnPath = Constants.CdnScriptDebugPrefix + Constants.HtmlEditorHtmlModeButtonName + Constants.DebugJsPostfix, CdnSupportsSecureConnection = true)]
[assembly: WebResource(Constants.HtmlEditorHtmlModeButtonName + Constants.JsPostfix, "text/javascript", CdnPath = Constants.CdnScriptReleasePrefix + Constants.HtmlEditorHtmlModeButtonName + Constants.JsPostfix, CdnSupportsSecureConnection = true)]
[assembly: WebResource(Constants.HtmlEditorToolbarName + Constants.DebugJsPostfix, "text/javascript", CdnPath = Constants.CdnScriptDebugPrefix + Constants.HtmlEditorToolbarName + Constants.DebugJsPostfix, CdnSupportsSecureConnection = true)]
[assembly: WebResource(Constants.HtmlEditorToolbarName + Constants.JsPostfix, "text/javascript", CdnPath = Constants.CdnScriptReleasePrefix + Constants.HtmlEditorToolbarName + Constants.JsPostfix, CdnSupportsSecureConnection = true)]
[assembly: WebResource(Constants.HtmlEditorImageButtonName + Constants.DebugJsPostfix, "text/javascript", CdnPath = Constants.CdnScriptDebugPrefix + Constants.HtmlEditorImageButtonName + Constants.DebugJsPostfix, CdnSupportsSecureConnection = true)]
[assembly: WebResource(Constants.HtmlEditorImageButtonName + Constants.JsPostfix, "text/javascript", CdnPath = Constants.CdnScriptReleasePrefix + Constants.HtmlEditorImageButtonName + Constants.JsPostfix, CdnSupportsSecureConnection = true)]
[assembly: WebResource(Constants.HtmlEditorIncreaseIndentButtonName + Constants.DebugJsPostfix, "text/javascript", CdnPath = Constants.CdnScriptDebugPrefix + Constants.HtmlEditorIncreaseIndentButtonName + Constants.DebugJsPostfix, CdnSupportsSecureConnection = true)]
[assembly: WebResource(Constants.HtmlEditorIncreaseIndentButtonName + Constants.JsPostfix, "text/javascript", CdnPath = Constants.CdnScriptReleasePrefix + Constants.HtmlEditorIncreaseIndentButtonName + Constants.JsPostfix, CdnSupportsSecureConnection = true)]
[assembly: WebResource(Constants.HtmlEditorInsertHRButtonName + Constants.DebugJsPostfix, "text/javascript", CdnPath = Constants.CdnScriptDebugPrefix + Constants.HtmlEditorInsertHRButtonName + Constants.DebugJsPostfix, CdnSupportsSecureConnection = true)]
[assembly: WebResource(Constants.HtmlEditorInsertHRButtonName + Constants.JsPostfix, "text/javascript", CdnPath = Constants.CdnScriptReleasePrefix + Constants.HtmlEditorInsertHRButtonName + Constants.JsPostfix, CdnSupportsSecureConnection = true)]
[assembly: WebResource(Constants.HtmlEditorInsertLinkButtonName + Constants.DebugJsPostfix, "text/javascript", CdnPath = Constants.CdnScriptDebugPrefix + Constants.HtmlEditorInsertLinkButtonName + Constants.DebugJsPostfix, CdnSupportsSecureConnection = true)]
[assembly: WebResource(Constants.HtmlEditorInsertLinkButtonName + Constants.JsPostfix, "text/javascript", CdnPath = Constants.CdnScriptReleasePrefix + Constants.HtmlEditorInsertLinkButtonName + Constants.JsPostfix, CdnSupportsSecureConnection = true)]
[assembly: WebResource(Constants.HtmlEditorJustifyCenterButtonName + Constants.DebugJsPostfix, "text/javascript", CdnPath = Constants.CdnScriptDebugPrefix + Constants.HtmlEditorJustifyCenterButtonName + Constants.DebugJsPostfix, CdnSupportsSecureConnection = true)]
[assembly: WebResource(Constants.HtmlEditorJustifyCenterButtonName + Constants.JsPostfix, "text/javascript", CdnPath = Constants.CdnScriptReleasePrefix + Constants.HtmlEditorJustifyCenterButtonName + Constants.JsPostfix, CdnSupportsSecureConnection = true)]
[assembly: WebResource(Constants.HtmlEditorJustifyFullButtonName + Constants.DebugJsPostfix, "text/javascript", CdnPath = Constants.CdnScriptDebugPrefix + Constants.HtmlEditorJustifyFullButtonName + Constants.DebugJsPostfix, CdnSupportsSecureConnection = true)]
[assembly: WebResource(Constants.HtmlEditorJustifyFullButtonName + Constants.JsPostfix, "text/javascript", CdnPath = Constants.CdnScriptReleasePrefix + Constants.HtmlEditorJustifyFullButtonName + Constants.JsPostfix, CdnSupportsSecureConnection = true)]
[assembly: WebResource(Constants.HtmlEditorJustifyLeftButtonName + Constants.DebugJsPostfix, "text/javascript", CdnPath = Constants.CdnScriptDebugPrefix + Constants.HtmlEditorJustifyLeftButtonName + Constants.DebugJsPostfix, CdnSupportsSecureConnection = true)]
[assembly: WebResource(Constants.HtmlEditorJustifyLeftButtonName + Constants.JsPostfix, "text/javascript", CdnPath = Constants.CdnScriptReleasePrefix + Constants.HtmlEditorJustifyLeftButtonName + Constants.JsPostfix, CdnSupportsSecureConnection = true)]
[assembly: WebResource(Constants.HtmlEditorJustifyRightButtonName + Constants.DebugJsPostfix, "text/javascript", CdnPath = Constants.CdnScriptDebugPrefix + Constants.HtmlEditorJustifyRightButtonName + Constants.DebugJsPostfix, CdnSupportsSecureConnection = true)]
[assembly: WebResource(Constants.HtmlEditorJustifyRightButtonName + Constants.JsPostfix, "text/javascript", CdnPath = Constants.CdnScriptReleasePrefix + Constants.HtmlEditorJustifyRightButtonName + Constants.JsPostfix, CdnSupportsSecureConnection = true)]
[assembly: WebResource(Constants.HtmlEditorLtrButtonName + Constants.DebugJsPostfix, "text/javascript", CdnPath = Constants.CdnScriptDebugPrefix + Constants.HtmlEditorLtrButtonName + Constants.DebugJsPostfix, CdnSupportsSecureConnection = true)]
[assembly: WebResource(Constants.HtmlEditorLtrButtonName + Constants.JsPostfix, "text/javascript", CdnPath = Constants.CdnScriptReleasePrefix + Constants.HtmlEditorLtrButtonName + Constants.JsPostfix, CdnSupportsSecureConnection = true)]
[assembly: WebResource(Constants.HtmlEditorMethodButtonName + Constants.DebugJsPostfix, "text/javascript", CdnPath = Constants.CdnScriptDebugPrefix + Constants.HtmlEditorMethodButtonName + Constants.DebugJsPostfix, CdnSupportsSecureConnection = true)]
[assembly: WebResource(Constants.HtmlEditorMethodButtonName + Constants.JsPostfix, "text/javascript", CdnPath = Constants.CdnScriptReleasePrefix + Constants.HtmlEditorMethodButtonName + Constants.JsPostfix, CdnSupportsSecureConnection = true)]
[assembly: WebResource(Constants.HtmlEditorOkCancelPopupButtonName + Constants.DebugJsPostfix, "text/javascript", CdnPath = Constants.CdnScriptDebugPrefix + Constants.HtmlEditorOkCancelPopupButtonName + Constants.DebugJsPostfix, CdnSupportsSecureConnection = true)]
[assembly: WebResource(Constants.HtmlEditorOkCancelPopupButtonName + Constants.JsPostfix, "text/javascript", CdnPath = Constants.CdnScriptReleasePrefix + Constants.HtmlEditorOkCancelPopupButtonName + Constants.JsPostfix, CdnSupportsSecureConnection = true)]
[assembly: WebResource(Constants.HtmlEditorOrderedListButtonName + Constants.DebugJsPostfix, "text/javascript", CdnPath = Constants.CdnScriptDebugPrefix + Constants.HtmlEditorOrderedListButtonName + Constants.DebugJsPostfix, CdnSupportsSecureConnection = true)]
[assembly: WebResource(Constants.HtmlEditorOrderedListButtonName + Constants.JsPostfix, "text/javascript", CdnPath = Constants.CdnScriptReleasePrefix + Constants.HtmlEditorOrderedListButtonName + Constants.JsPostfix, CdnSupportsSecureConnection = true)]
[assembly: WebResource(Constants.HtmlEditorParagraphButtonName + Constants.DebugJsPostfix, "text/javascript", CdnPath = Constants.CdnScriptDebugPrefix + Constants.HtmlEditorParagraphButtonName + Constants.DebugJsPostfix, CdnSupportsSecureConnection = true)]
[assembly: WebResource(Constants.HtmlEditorParagraphButtonName + Constants.JsPostfix, "text/javascript", CdnPath = Constants.CdnScriptReleasePrefix + Constants.HtmlEditorParagraphButtonName + Constants.JsPostfix, CdnSupportsSecureConnection = true)]
[assembly: WebResource(Constants.HtmlEditorPasteButtonName + Constants.DebugJsPostfix, "text/javascript", CdnPath = Constants.CdnScriptDebugPrefix + Constants.HtmlEditorPasteButtonName + Constants.DebugJsPostfix, CdnSupportsSecureConnection = true)]
[assembly: WebResource(Constants.HtmlEditorPasteButtonName + Constants.JsPostfix, "text/javascript", CdnPath = Constants.CdnScriptReleasePrefix + Constants.HtmlEditorPasteButtonName + Constants.JsPostfix, CdnSupportsSecureConnection = true)]
[assembly: WebResource(Constants.HtmlEditorPasteTextButtonName + Constants.DebugJsPostfix, "text/javascript", CdnPath = Constants.CdnScriptDebugPrefix + Constants.HtmlEditorPasteTextButtonName + Constants.DebugJsPostfix, CdnSupportsSecureConnection = true)]
[assembly: WebResource(Constants.HtmlEditorPasteTextButtonName + Constants.JsPostfix, "text/javascript", CdnPath = Constants.CdnScriptReleasePrefix + Constants.HtmlEditorPasteTextButtonName + Constants.JsPostfix, CdnSupportsSecureConnection = true)]
[assembly: WebResource(Constants.HtmlEditorPasteWordButtonName + Constants.DebugJsPostfix, "text/javascript", CdnPath = Constants.CdnScriptDebugPrefix + Constants.HtmlEditorPasteWordButtonName + Constants.DebugJsPostfix, CdnSupportsSecureConnection = true)]
[assembly: WebResource(Constants.HtmlEditorPasteWordButtonName + Constants.JsPostfix, "text/javascript", CdnPath = Constants.CdnScriptReleasePrefix + Constants.HtmlEditorPasteWordButtonName + Constants.JsPostfix, CdnSupportsSecureConnection = true)]
[assembly: WebResource(Constants.HtmlEditorPreviewModeButtonName + Constants.DebugJsPostfix, "text/javascript", CdnPath = Constants.CdnScriptDebugPrefix + Constants.HtmlEditorPreviewModeButtonName + Constants.DebugJsPostfix, CdnSupportsSecureConnection = true)]
[assembly: WebResource(Constants.HtmlEditorPreviewModeButtonName + Constants.JsPostfix, "text/javascript", CdnPath = Constants.CdnScriptReleasePrefix + Constants.HtmlEditorPreviewModeButtonName + Constants.JsPostfix, CdnSupportsSecureConnection = true)]
[assembly: WebResource(Constants.HtmlEditorRedoButtonMode + Constants.DebugJsPostfix, "text/javascript", CdnPath = Constants.CdnScriptDebugPrefix + Constants.HtmlEditorRedoButtonMode + Constants.DebugJsPostfix, CdnSupportsSecureConnection = true)]
[assembly: WebResource(Constants.HtmlEditorRedoButtonMode + Constants.JsPostfix, "text/javascript", CdnPath = Constants.CdnScriptReleasePrefix + Constants.HtmlEditorRedoButtonMode + Constants.JsPostfix, CdnSupportsSecureConnection = true)]
[assembly: WebResource(Constants.HtmlEditorRemoveAlignmentButtonName + Constants.DebugJsPostfix, "text/javascript", CdnPath = Constants.CdnScriptDebugPrefix + Constants.HtmlEditorRemoveAlignmentButtonName + Constants.DebugJsPostfix, CdnSupportsSecureConnection = true)]
[assembly: WebResource(Constants.HtmlEditorRemoveAlignmentButtonName + Constants.JsPostfix, "text/javascript", CdnPath = Constants.CdnScriptReleasePrefix + Constants.HtmlEditorRemoveAlignmentButtonName + Constants.JsPostfix, CdnSupportsSecureConnection = true)]
[assembly: WebResource(Constants.HtmlEditorRemoveLinkButtonName + Constants.DebugJsPostfix, "text/javascript", CdnPath = Constants.CdnScriptDebugPrefix + Constants.HtmlEditorRemoveLinkButtonName + Constants.DebugJsPostfix, CdnSupportsSecureConnection = true)]
[assembly: WebResource(Constants.HtmlEditorRemoveLinkButtonName + Constants.JsPostfix, "text/javascript", CdnPath = Constants.CdnScriptReleasePrefix + Constants.HtmlEditorRemoveLinkButtonName + Constants.JsPostfix, CdnSupportsSecureConnection = true)]
[assembly: WebResource(Constants.HtmlEditorRemoveStylesButtonName + Constants.DebugJsPostfix, "text/javascript", CdnPath = Constants.CdnScriptDebugPrefix + Constants.HtmlEditorRemoveStylesButtonName + Constants.DebugJsPostfix, CdnSupportsSecureConnection = true)]
[assembly: WebResource(Constants.HtmlEditorRemoveStylesButtonName + Constants.JsPostfix, "text/javascript", CdnPath = Constants.CdnScriptReleasePrefix + Constants.HtmlEditorRemoveStylesButtonName + Constants.JsPostfix, CdnSupportsSecureConnection = true)]
[assembly: WebResource(Constants.HtmlEditorRtlButtonName + Constants.DebugJsPostfix, "text/javascript", CdnPath = Constants.CdnScriptDebugPrefix + Constants.HtmlEditorRtlButtonName + Constants.DebugJsPostfix, CdnSupportsSecureConnection = true)]
[assembly: WebResource(Constants.HtmlEditorRtlButtonName + Constants.JsPostfix, "text/javascript", CdnPath = Constants.CdnScriptReleasePrefix + Constants.HtmlEditorRtlButtonName + Constants.JsPostfix, CdnSupportsSecureConnection = true)]
[assembly: WebResource(Constants.HtmlEditorSelectButtonName + Constants.DebugJsPostfix, "text/javascript", CdnPath = Constants.CdnScriptDebugPrefix + Constants.HtmlEditorSelectButtonName + Constants.DebugJsPostfix, CdnSupportsSecureConnection = true)]
[assembly: WebResource(Constants.HtmlEditorSelectButtonName + Constants.JsPostfix, "text/javascript", CdnPath = Constants.CdnScriptReleasePrefix + Constants.HtmlEditorSelectButtonName + Constants.JsPostfix, CdnSupportsSecureConnection = true)]
[assembly: WebResource(Constants.HtmlEditorSelectorButtonName + Constants.DebugJsPostfix, "text/javascript", CdnPath = Constants.CdnScriptDebugPrefix + Constants.HtmlEditorSelectorButtonName + Constants.DebugJsPostfix, CdnSupportsSecureConnection = true)]
[assembly: WebResource(Constants.HtmlEditorSelectorButtonName + Constants.JsPostfix, "text/javascript", CdnPath = Constants.CdnScriptReleasePrefix + Constants.HtmlEditorSelectorButtonName + Constants.JsPostfix, CdnSupportsSecureConnection = true)]
[assembly: WebResource(Constants.HtmlEditorStrikeThroughButtonName + Constants.DebugJsPostfix, "text/javascript", CdnPath = Constants.CdnScriptDebugPrefix + Constants.HtmlEditorStrikeThroughButtonName + Constants.DebugJsPostfix, CdnSupportsSecureConnection = true)]
[assembly: WebResource(Constants.HtmlEditorStrikeThroughButtonName + Constants.JsPostfix, "text/javascript", CdnPath = Constants.CdnScriptReleasePrefix + Constants.HtmlEditorStrikeThroughButtonName + Constants.JsPostfix, CdnSupportsSecureConnection = true)]
[assembly: WebResource(Constants.HtmlEditorSubScriptButtonName + Constants.DebugJsPostfix, "text/javascript", CdnPath = Constants.CdnScriptDebugPrefix + Constants.HtmlEditorSubScriptButtonName + Constants.DebugJsPostfix, CdnSupportsSecureConnection = true)]
[assembly: WebResource(Constants.HtmlEditorSubScriptButtonName + Constants.JsPostfix, "text/javascript", CdnPath = Constants.CdnScriptReleasePrefix + Constants.HtmlEditorSubScriptButtonName + Constants.JsPostfix, CdnSupportsSecureConnection = true)]
[assembly: WebResource(Constants.HtmlEditorSuperScriptButtonName + Constants.DebugJsPostfix, "text/javascript", CdnPath = Constants.CdnScriptDebugPrefix + Constants.HtmlEditorSuperScriptButtonName + Constants.DebugJsPostfix, CdnSupportsSecureConnection = true)]
[assembly: WebResource(Constants.HtmlEditorSuperScriptButtonName + Constants.JsPostfix, "text/javascript", CdnPath = Constants.CdnScriptReleasePrefix + Constants.HtmlEditorSuperScriptButtonName + Constants.JsPostfix, CdnSupportsSecureConnection = true)]
[assembly: WebResource(Constants.HtmlEditorUnderlineButtonName + Constants.DebugJsPostfix, "text/javascript", CdnPath = Constants.CdnScriptDebugPrefix + Constants.HtmlEditorUnderlineButtonName + Constants.DebugJsPostfix, CdnSupportsSecureConnection = true)]
[assembly: WebResource(Constants.HtmlEditorUnderlineButtonName + Constants.JsPostfix, "text/javascript", CdnPath = Constants.CdnScriptReleasePrefix + Constants.HtmlEditorUnderlineButtonName + Constants.JsPostfix, CdnSupportsSecureConnection = true)]
[assembly: WebResource(Constants.HtmlEditorUndoButtonName + Constants.DebugJsPostfix, "text/javascript", CdnPath = Constants.CdnScriptDebugPrefix + Constants.HtmlEditorUndoButtonName + Constants.DebugJsPostfix, CdnSupportsSecureConnection = true)]
[assembly: WebResource(Constants.HtmlEditorUndoButtonName + Constants.JsPostfix, "text/javascript", CdnPath = Constants.CdnScriptReleasePrefix + Constants.HtmlEditorUndoButtonName + Constants.JsPostfix, CdnSupportsSecureConnection = true)]

[assembly: WebResource(Constants.StyleResourcePrefix + Constants.HtmlEditorEditorName + Constants.CssPostfix, "text/css")]
[assembly: WebResource(Constants.StyleResourcePrefix + Constants.HtmlEditorEditorName + Constants.MinCssPostfix, "text/css")]
[assembly: WebResource(Constants.StyleResourcePrefix + Constants.HtmlEditorAttachedTemplatePopupName + Constants.CssPostfix, "text/css", PerformSubstitution = true)]
[assembly: WebResource(Constants.StyleResourcePrefix + Constants.HtmlEditorAttachedTemplatePopupName + Constants.MinCssPostfix, "text/css", PerformSubstitution = true)]
[assembly: WebResource(Constants.StyleResourcePrefix + Constants.HtmlEditorHtmlPanelName + Constants.CssPostfix, "text/css")]
[assembly: WebResource(Constants.StyleResourcePrefix + Constants.HtmlEditorHtmlPanelName + Constants.MinCssPostfix, "text/css")]
[assembly: WebResource(Constants.StyleResourcePrefix + Constants.HtmlEditorDocumentName + Constants.CssPostfix, "text/css")]
[assembly: WebResource(Constants.StyleResourcePrefix + Constants.HtmlEditorDocumentName + Constants.MinCssPostfix, "text/css")]
[assembly: WebResource(Constants.StyleResourcePrefix + Constants.HtmlEditorDesignPanelName + Constants.CssPostfix, "text/css")]
[assembly: WebResource(Constants.StyleResourcePrefix + Constants.HtmlEditorDesignPanelName + Constants.MinCssPostfix, "text/css")]

[assembly: WebResource(Constants.ImageResourcePrefix + Constants.HtmlEditorBgiButtonImage, "image/gif")]
[assembly: WebResource(Constants.ImageResourcePrefix + Constants.HtmlEditorEdColorBgClearAImage, "image/gif")]
[assembly: WebResource(Constants.ImageResourcePrefix + Constants.HtmlEditorEdColorBgClearNImage, "image/gif")]
[assembly: WebResource(Constants.ImageResourcePrefix + Constants.HtmlEditorEdFormatBoldAImage, "image/gif")]
[assembly: WebResource(Constants.ImageResourcePrefix + Constants.HtmlEditorEdFormatBoldNImage, "image/gif")]
[assembly: WebResource(Constants.ImageResourcePrefix + Constants.HtmlEditorEdListBulletAImage, "image/gif")]
[assembly: WebResource(Constants.ImageResourcePrefix + Constants.HtmlEditorEdListBulletNImage, "image/gif")]
[assembly: WebResource(Constants.ImageResourcePrefix + Constants.HtmlEditorEdCopyAImage, "image/gif")]
[assembly: WebResource(Constants.ImageResourcePrefix + Constants.HtmlEditorEdCopyNImage, "image/gif")]
[assembly: WebResource(Constants.ImageResourcePrefix + Constants.HtmlEditorEdCutAImage, "image/gif")]
[assembly: WebResource(Constants.ImageResourcePrefix + Constants.HtmlEditorEdCutNImage, "image/gif")]
[assembly: WebResource(Constants.ImageResourcePrefix + Constants.HtmlEditorEdIndentLessAImage, "image/gif")]
[assembly: WebResource(Constants.ImageResourcePrefix + Constants.HtmlEditorEdIndentLessNImage, "image/gif")]
[assembly: WebResource(Constants.ImageResourcePrefix + Constants.HtmlEditorEdDesignAImage, "image/gif")]
[assembly: WebResource(Constants.ImageResourcePrefix + Constants.HtmlEditorEdDesignNImage, "image/gif")]
[assembly: WebResource(Constants.ImageResourcePrefix + Constants.HtmlEditorEdBackColorAImage, "image/gif")]
[assembly: WebResource(Constants.ImageResourcePrefix + Constants.HtmlEditorEdBackColorNImage, "image/gif")]
[assembly: WebResource(Constants.ImageResourcePrefix + Constants.HtmlEditorEdForeColorAImage, "image/gif")]
[assembly: WebResource(Constants.ImageResourcePrefix + Constants.HtmlEditorEdForeColorNImage, "image/gif")]
[assembly: WebResource(Constants.ImageResourcePrefix + Constants.HtmlEditorEdColorFgAImage, "image/gif")]
[assembly: WebResource(Constants.ImageResourcePrefix + Constants.HtmlEditorEdColorFgNImage, "image/gif")]
[assembly: WebResource(Constants.ImageResourcePrefix + Constants.HtmlEditorEdColorFgClearAImage, "image/gif")]
[assembly: WebResource(Constants.ImageResourcePrefix + Constants.HtmlEditorEdColorFgClearNImage, "image/gif")]
[assembly: WebResource(Constants.ImageResourcePrefix + Constants.HtmlEditorEdSepImage, "image/gif")]
[assembly: WebResource(Constants.ImageResourcePrefix + Constants.HtmlEditorEdHtmlAImage, "image/gif")]
[assembly: WebResource(Constants.ImageResourcePrefix + Constants.HtmlEditorEdHtmlNImage, "image/gif")]
[assembly: WebResource(Constants.ImageResourcePrefix + Constants.HtmlEditorEdIndentMoreAImage, "image/gif")]
[assembly: WebResource(Constants.ImageResourcePrefix + Constants.HtmlEditorEdIndentMoreNImage, "image/gif")]
[assembly: WebResource(Constants.ImageResourcePrefix + Constants.HtmlEditorEdRuleAImage, "image/gif")]
[assembly: WebResource(Constants.ImageResourcePrefix + Constants.HtmlEditorEdRuleNImage, "image/gif")]
[assembly: WebResource(Constants.ImageResourcePrefix + Constants.HtmlEditorEdLinkAImage, "image/gif")]
[assembly: WebResource(Constants.ImageResourcePrefix + Constants.HtmlEditorEdLinkNImage, "image/gif")]
[assembly: WebResource(Constants.ImageResourcePrefix + Constants.HtmlEditorItalicButtonName, "image/gif")]
[assembly: WebResource(Constants.ImageResourcePrefix + Constants.HtmlEditorItalicButtonName, "image/gif")]
[assembly: WebResource(Constants.ImageResourcePrefix + Constants.HtmlEditorEdFormatItalicAImage, "image/gif")]
[assembly: WebResource(Constants.ImageResourcePrefix + Constants.HtmlEditorEdFormatItalicNImage, "image/gif")]
[assembly: WebResource(Constants.ImageResourcePrefix + Constants.HtmlEditorEdAlingCenterAImage, "image/gif")]
[assembly: WebResource(Constants.ImageResourcePrefix + Constants.HtmlEditorEdAlingCenterNImage, "image/gif")]
[assembly: WebResource(Constants.ImageResourcePrefix + Constants.HtmlEditorEdAlignJustifyAImage, "image/gif")]
[assembly: WebResource(Constants.ImageResourcePrefix + Constants.HtmlEditorEdAlignJustifyNImage, "image/gif")]
[assembly: WebResource(Constants.ImageResourcePrefix + Constants.HtmlEditorEdAlignLeftAImage, "image/gif")]
[assembly: WebResource(Constants.ImageResourcePrefix + Constants.HtmlEditorEdAlignLeftNImage, "image/gif")]
[assembly: WebResource(Constants.ImageResourcePrefix + Constants.HtmlEditorEdAlignRightAImage, "image/gif")]
[assembly: WebResource(Constants.ImageResourcePrefix + Constants.HtmlEditorEdAlignRightNImage, "image/gif")]
[assembly: WebResource(Constants.ImageResourcePrefix + Constants.HtmlEditorEdFormatLtrAImage, "image/gif")]
[assembly: WebResource(Constants.ImageResourcePrefix + Constants.HtmlEditorEdFormatLtrNImage, "image/gif")]
[assembly: WebResource(Constants.ImageResourcePrefix + Constants.HtmlEditorEdListNumAImage, "image/gif")]
[assembly: WebResource(Constants.ImageResourcePrefix + Constants.HtmlEditorEdListNumNImage, "image/gif")]
[assembly: WebResource(Constants.ImageResourcePrefix + Constants.HtmlEditorEdFormatParagraphAImage, "image/gif")]
[assembly: WebResource(Constants.ImageResourcePrefix + Constants.HtmlEditorEdFormatParagraphNImage, "image/gif")]
[assembly: WebResource(Constants.ImageResourcePrefix + Constants.HtmlEditorEdPasteAImage, "image/gif")]
[assembly: WebResource(Constants.ImageResourcePrefix + Constants.HtmlEditorEdPasteNImage, "image/gif")]
[assembly: WebResource(Constants.ImageResourcePrefix + Constants.HtmlEditorEdPasteTextAImage, "image/gif")]
[assembly: WebResource(Constants.ImageResourcePrefix + Constants.HtmlEditorEdPasteTextNImage, "image/gif")]
[assembly: WebResource(Constants.ImageResourcePrefix + Constants.HtmlEditorEdPasteWordAImage, "image/gif")]
[assembly: WebResource(Constants.ImageResourcePrefix + Constants.HtmlEditorEdPasteWordNImage, "image/gif")]
[assembly: WebResource(Constants.ImageResourcePrefix + Constants.HtmlEditorEdPreviewAImage, "image/gif")]
[assembly: WebResource(Constants.ImageResourcePrefix + Constants.HtmlEditorEdPreviewNImage, "image/gif")]
[assembly: WebResource(Constants.ImageResourcePrefix + Constants.HtmlEditorEdRedoAImage, "image/gif")]
[assembly: WebResource(Constants.ImageResourcePrefix + Constants.HtmlEditorEdRedoNImage, "image/gif")]
[assembly: WebResource(Constants.ImageResourcePrefix + Constants.HtmlEditorEdRemoveAlignAImage, "image/gif")]
[assembly: WebResource(Constants.ImageResourcePrefix + Constants.HtmlEditorEdRemoveAlignNImage, "image/gif")]
[assembly: WebResource(Constants.ImageResourcePrefix + Constants.HtmlEditorEdUnlinkAImage, "image/gif")]
[assembly: WebResource(Constants.ImageResourcePrefix + Constants.HtmlEditorEdUnlinkNImage, "image/gif")]
[assembly: WebResource(Constants.ImageResourcePrefix + Constants.HtmlEditorEdUnformatAImage, "image/gif")]
[assembly: WebResource(Constants.ImageResourcePrefix + Constants.HtmlEditorEdUnformatNImage, "image/gif")]
[assembly: WebResource(Constants.ImageResourcePrefix + Constants.HtmlEditorEdFormatRtlAImage, "image/gif")]
[assembly: WebResource(Constants.ImageResourcePrefix + Constants.HtmlEditorEdFormatRtlNImage, "image/gif")]
[assembly: WebResource(Constants.ImageResourcePrefix + Constants.HtmlEditorEdSelectorAImage, "image/gif")]
[assembly: WebResource(Constants.ImageResourcePrefix + Constants.HtmlEditorEdSelectorNImage, "image/gif")]
[assembly: WebResource(Constants.ImageResourcePrefix + Constants.HtmlEditorEdFormatStrikeAImage, "image/gif")]
[assembly: WebResource(Constants.ImageResourcePrefix + Constants.HtmlEditorEdFormatStrikeNImage, "image/gif")]
[assembly: WebResource(Constants.ImageResourcePrefix + Constants.HtmlEditorEdFormatSubAImage, "image/gif")]
[assembly: WebResource(Constants.ImageResourcePrefix + Constants.HtmlEditorEdFormatSubNImage, "image/gif")]
[assembly: WebResource(Constants.ImageResourcePrefix + Constants.HtmlEditorEdFormatSupAImage, "image/gif")]
[assembly: WebResource(Constants.ImageResourcePrefix + Constants.HtmlEditorEdFormatSupNImage, "image/gif")]
[assembly: WebResource(Constants.ImageResourcePrefix + Constants.HtmlEditorEdFormatUnderlineAImage, "image/gif")]
[assembly: WebResource(Constants.ImageResourcePrefix + Constants.HtmlEditorEdFormatUnderlineNImage, "image/gif")]
[assembly: WebResource(Constants.ImageResourcePrefix + Constants.HtmlEditorEdUndoAImage, "image/gif")]
[assembly: WebResource(Constants.ImageResourcePrefix + Constants.HtmlEditorEdUndoNImage, "image/gif")]
[assembly: WebResource(Constants.ImageResourcePrefix + Constants.HtmlEditorEd1x1Image, "image/gif")]
[assembly: WebResource(Constants.ImageResourcePrefix + Constants.HtmlEditorEdAnchorImage, "image/gif")]
[assembly: WebResource(Constants.ImageResourcePrefix + Constants.HtmlEditorEdFlashImage, "image/gif")]
[assembly: WebResource(Constants.ImageResourcePrefix + Constants.HtmlEditorEdMediaImage, "image/gif")]
[assembly: WebResource(Constants.ImageResourcePrefix + Constants.HtmlEditorEdPlaceHolderImage, "image/gif")]
[assembly: WebResource(Constants.ImageResourcePrefix + Constants.HtmlEditorExtenderButtonsImage, "image/png")]

[assembly: WebResource(Constants.LineChartName + Constants.DebugJsPostfix, "text/javascript", CdnPath = Constants.CdnScriptDebugPrefix + Constants.LineChartName + Constants.DebugJsPostfix, CdnSupportsSecureConnection = true)]
[assembly: WebResource(Constants.LineChartName + Constants.JsPostfix, "text/javascript", CdnPath = Constants.CdnScriptReleasePrefix + Constants.LineChartName + Constants.JsPostfix, CdnSupportsSecureConnection = true)]
[assembly: WebResource(Constants.StyleResourcePrefix + Constants.LineChartName + Constants.CssPostfix, "text/css")]
[assembly: WebResource(Constants.StyleResourcePrefix + Constants.LineChartName + Constants.MinCssPostfix, "text/css")]

[assembly: WebResource(Constants.ListSearchName + Constants.DebugJsPostfix, "text/javascript", CdnPath = Constants.CdnScriptDebugPrefix + Constants.ListSearchName + Constants.DebugJsPostfix, CdnSupportsSecureConnection = true)]
[assembly: WebResource(Constants.ListSearchName + Constants.JsPostfix, "text/javascript", CdnPath = Constants.CdnScriptReleasePrefix + Constants.ListSearchName + Constants.JsPostfix, CdnSupportsSecureConnection = true)]

[assembly: WebResource(Constants.MaskedEditName + Constants.DebugJsPostfix, "text/javascript", CdnPath = Constants.CdnScriptDebugPrefix + Constants.MaskedEditName + Constants.DebugJsPostfix, CdnSupportsSecureConnection = true)]
[assembly: WebResource(Constants.MaskedEditName + Constants.JsPostfix, "text/javascript", CdnPath = Constants.CdnScriptReleasePrefix + Constants.MaskedEditName + Constants.JsPostfix, CdnSupportsSecureConnection = true)]
[assembly: WebResource(Constants.MaskedEditValidatorName + Constants.DebugJsPostfix, "text/javascript", CdnPath = Constants.CdnScriptDebugPrefix + Constants.MaskedEditValidatorName + Constants.DebugJsPostfix, CdnSupportsSecureConnection = true)]
[assembly: WebResource(Constants.MaskedEditValidatorName + Constants.JsPostfix, "text/javascript", CdnPath = Constants.CdnScriptReleasePrefix + Constants.MaskedEditValidatorName + Constants.JsPostfix, CdnSupportsSecureConnection = true)]

[assembly: WebResource(Constants.ModalPopup + Constants.DebugJsPostfix, "text/javascript", CdnPath = Constants.CdnScriptDebugPrefix + Constants.ModalPopup + Constants.DebugJsPostfix, CdnSupportsSecureConnection = true)]
[assembly: WebResource(Constants.ModalPopup + Constants.JsPostfix, "text/javascript", CdnPath = Constants.CdnScriptReleasePrefix + Constants.ModalPopup + Constants.JsPostfix, CdnSupportsSecureConnection = true)]

[assembly: WebResource(Constants.MultiHandleSliderName + Constants.DebugJsPostfix, "text/javascript", CdnPath = Constants.CdnScriptDebugPrefix + Constants.MultiHandleSliderName + Constants.DebugJsPostfix, CdnSupportsSecureConnection = true)]
[assembly: WebResource(Constants.MultiHandleSliderName + Constants.JsPostfix, "text/javascript", CdnPath = Constants.CdnScriptReleasePrefix + Constants.MultiHandleSliderName + Constants.JsPostfix, CdnSupportsSecureConnection = true)]
[assembly: WebResource(Constants.StyleResourcePrefix + Constants.MultiHandleSliderName + Constants.CssPostfix, "text/css", PerformSubstitution = true)]
[assembly: WebResource(Constants.StyleResourcePrefix + Constants.MultiHandleSliderName + Constants.MinCssPostfix, "text/css", PerformSubstitution = true)]
[assembly: WebResource(Constants.ImageResourcePrefix + Constants.MultiHandleSliderHHandleImage, "image/gif")]
[assembly: WebResource(Constants.ImageResourcePrefix + Constants.MultiHandleSliderHHandleDownImage, "image/gif")]
[assembly: WebResource(Constants.ImageResourcePrefix + Constants.MultiHandleSliderHHandleHoverImage, "image/gif")]
[assembly: WebResource(Constants.ImageResourcePrefix + Constants.MultiHandleSliderHRailImage, "image/gif")]
[assembly: WebResource(Constants.ImageResourcePrefix + Constants.MultiHandleSliderHRailOuterImage, "image/gif")]
[assembly: WebResource(Constants.ImageResourcePrefix + Constants.MultiHandleSliderVHandleImage, "image/gif")]
[assembly: WebResource(Constants.ImageResourcePrefix + Constants.MultiHandleSliderVHandleDownImage, "image/gif")]
[assembly: WebResource(Constants.ImageResourcePrefix + Constants.MultiHandleSliderVHandleHoverImage, "image/gif")]
[assembly: WebResource(Constants.ImageResourcePrefix + Constants.MultiHandleSliderVRailImage, "image/gif")]
[assembly: WebResource(Constants.ImageResourcePrefix + Constants.MultiHandleSliderVRailOuterImage, "image/gif")]

[assembly: WebResource(Constants.MutuallyExclusiveCheckBoxName + Constants.DebugJsPostfix, "text/javascript", CdnPath = Constants.CdnScriptDebugPrefix + Constants.MutuallyExclusiveCheckBoxName + Constants.DebugJsPostfix, CdnSupportsSecureConnection = true)]
[assembly: WebResource(Constants.MutuallyExclusiveCheckBoxName + Constants.JsPostfix, "text/javascript", CdnPath = Constants.CdnScriptReleasePrefix + Constants.MutuallyExclusiveCheckBoxName + Constants.JsPostfix, CdnSupportsSecureConnection = true)]

[assembly: WebResource(Constants.NoBotName + Constants.DebugJsPostfix, "text/javascript", CdnPath = Constants.CdnScriptDebugPrefix + Constants.NoBotName + Constants.DebugJsPostfix, CdnSupportsSecureConnection = true)]
[assembly: WebResource(Constants.NoBotName + Constants.JsPostfix, "text/javascript", CdnPath = Constants.CdnScriptReleasePrefix + Constants.NoBotName + Constants.JsPostfix, CdnSupportsSecureConnection = true)]

[assembly: WebResource(Constants.NumericUpDownName + Constants.DebugJsPostfix, "text/javascript", CdnPath = Constants.CdnScriptDebugPrefix + Constants.NumericUpDownName + Constants.DebugJsPostfix, CdnSupportsSecureConnection = true)]
[assembly: WebResource(Constants.NumericUpDownName + Constants.JsPostfix, "text/javascript", CdnPath = Constants.CdnScriptReleasePrefix + Constants.NumericUpDownName + Constants.JsPostfix, CdnSupportsSecureConnection = true)]
[assembly: WebResource(Constants.StyleResourcePrefix + Constants.NumericUpDownName + Constants.CssPostfix, "text/css")]
[assembly: WebResource(Constants.StyleResourcePrefix + Constants.NumericUpDownName + Constants.MinCssPostfix, "text/css")]

[assembly: WebResource(Constants.PagingBulletedListName + Constants.DebugJsPostfix, "text/javascript", CdnPath = Constants.CdnScriptDebugPrefix + Constants.PagingBulletedListName + Constants.DebugJsPostfix, CdnSupportsSecureConnection = true)]
[assembly: WebResource(Constants.PagingBulletedListName + Constants.JsPostfix, "text/javascript", CdnPath = Constants.CdnScriptReleasePrefix + Constants.PagingBulletedListName + Constants.JsPostfix, CdnSupportsSecureConnection = true)]

[assembly: WebResource(Constants.PasswordStrengthName + Constants.DebugJsPostfix, "text/javascript", CdnPath = Constants.CdnScriptDebugPrefix + Constants.PasswordStrengthName + Constants.DebugJsPostfix, CdnSupportsSecureConnection = true)]
[assembly: WebResource(Constants.PasswordStrengthName + Constants.JsPostfix, "text/javascript", CdnPath = Constants.CdnScriptReleasePrefix + Constants.PasswordStrengthName + Constants.JsPostfix, CdnSupportsSecureConnection = true)]

[assembly: WebResource(Constants.PieChartName + Constants.DebugJsPostfix, "text/javascript", CdnPath = Constants.CdnScriptDebugPrefix + Constants.PieChartName + Constants.DebugJsPostfix, CdnSupportsSecureConnection = true)]
[assembly: WebResource(Constants.PieChartName + Constants.JsPostfix, "text/javascript", CdnPath = Constants.CdnScriptReleasePrefix + Constants.PieChartName + Constants.JsPostfix, CdnSupportsSecureConnection = true)]
[assembly: WebResource(Constants.StyleResourcePrefix + Constants.PieChartName + Constants.CssPostfix, "text/css")]
[assembly: WebResource(Constants.StyleResourcePrefix + Constants.PieChartName + Constants.MinCssPostfix, "text/css")]

[assembly: WebResource(Constants.PopupControlName + Constants.DebugJsPostfix, "text/javascript", CdnPath = Constants.CdnScriptDebugPrefix + Constants.PopupControlName + Constants.DebugJsPostfix, CdnSupportsSecureConnection = true)]
[assembly: WebResource(Constants.PopupControlName + Constants.JsPostfix, "text/javascript", CdnPath = Constants.CdnScriptReleasePrefix + Constants.PopupControlName + Constants.JsPostfix, CdnSupportsSecureConnection = true)]

[assembly: WebResource(Constants.PopupName + Constants.DebugJsPostfix, "text/javascript", CdnPath = Constants.CdnScriptDebugPrefix + Constants.PopupName + Constants.DebugJsPostfix, CdnSupportsSecureConnection = true)]
[assembly: WebResource(Constants.PopupName + Constants.JsPostfix, "text/javascript", CdnPath = Constants.CdnScriptReleasePrefix + Constants.PopupName + Constants.JsPostfix, CdnSupportsSecureConnection = true)]

[assembly: WebResource(Constants.RatingName + Constants.DebugJsPostfix, "text/javascript", CdnPath = Constants.CdnScriptDebugPrefix + Constants.RatingName + Constants.DebugJsPostfix, CdnSupportsSecureConnection = true)]
[assembly: WebResource(Constants.RatingName + Constants.JsPostfix, "text/javascript", CdnPath = Constants.CdnScriptReleasePrefix + Constants.RatingName + Constants.JsPostfix, CdnSupportsSecureConnection = true)]

[assembly: WebResource(Constants.ResizableControlName + Constants.DebugJsPostfix, "text/javascript", CdnPath = Constants.CdnScriptDebugPrefix + Constants.ResizableControlName + Constants.DebugJsPostfix, CdnSupportsSecureConnection = true)]
[assembly: WebResource(Constants.ResizableControlName + Constants.JsPostfix, "text/javascript", CdnPath = Constants.CdnScriptReleasePrefix + Constants.ResizableControlName + Constants.JsPostfix, CdnSupportsSecureConnection = true)]

[assembly: WebResource(Constants.RoundedCornersName + Constants.DebugJsPostfix, "text/javascript", CdnPath = Constants.CdnScriptDebugPrefix + Constants.RoundedCornersName + Constants.DebugJsPostfix, CdnSupportsSecureConnection = true)]
[assembly: WebResource(Constants.RoundedCornersName + Constants.JsPostfix, "text/javascript", CdnPath = Constants.CdnScriptReleasePrefix + Constants.RoundedCornersName + Constants.JsPostfix, CdnSupportsSecureConnection = true)]

[assembly: WebResource(Constants.SeadragonName + Constants.DebugJsPostfix, "text/javascript", CdnPath = Constants.CdnScriptDebugPrefix + Constants.SeadragonName + Constants.DebugJsPostfix, CdnSupportsSecureConnection = true, PerformSubstitution = true)]
[assembly: WebResource(Constants.SeadragonName + Constants.JsPostfix, "text/javascript", CdnPath = Constants.CdnScriptReleasePrefix + Constants.SeadragonName + Constants.JsPostfix, CdnSupportsSecureConnection = true, PerformSubstitution = true)]
[assembly: WebResource(Constants.ImageResourcePrefix + Constants.SeadragonFullpageGrouphoverImage, "image/png")]
[assembly: WebResource(Constants.ImageResourcePrefix + Constants.SeadragonFullpageHoverImage, "image/png")]
[assembly: WebResource(Constants.ImageResourcePrefix + Constants.SeadragonFullpagePressedImage, "image/png")]
[assembly: WebResource(Constants.ImageResourcePrefix + Constants.SeadragonFullpageRestImage, "image/png")]
[assembly: WebResource(Constants.ImageResourcePrefix + Constants.SeadragonHomeGrouphoverImage, "image/png")]
[assembly: WebResource(Constants.ImageResourcePrefix + Constants.SeadragonHomeHoverImage, "image/png")]
[assembly: WebResource(Constants.ImageResourcePrefix + Constants.SeadragonHomePressedImage, "image/png")]
[assembly: WebResource(Constants.ImageResourcePrefix + Constants.SeadragonHomeRestImage, "image/png")]
[assembly: WebResource(Constants.ImageResourcePrefix + Constants.SeadragonZoominGrouphoverImage, "image/png")]
[assembly: WebResource(Constants.ImageResourcePrefix + Constants.SeadragonZoominHoverImage, "image/png")]
[assembly: WebResource(Constants.ImageResourcePrefix + Constants.SeadragonZoominPressedImage, "image/png")]
[assembly: WebResource(Constants.ImageResourcePrefix + Constants.SeadragonZoominRestImage, "image/png")]
[assembly: WebResource(Constants.ImageResourcePrefix + Constants.SeadragonZoomoutGrouphoverImage, "image/png")]
[assembly: WebResource(Constants.ImageResourcePrefix + Constants.SeadragonZoomoutHoverImage, "image/png")]
[assembly: WebResource(Constants.ImageResourcePrefix + Constants.SeadragonZoomoutPressedImage, "image/png")]
[assembly: WebResource(Constants.ImageResourcePrefix + Constants.SeadragonZoomoutRestImage, "image/png")]

[assembly: WebResource(Constants.SliderName + Constants.DebugJsPostfix, "text/javascript", CdnPath = Constants.CdnScriptDebugPrefix + Constants.SliderName + Constants.DebugJsPostfix, CdnSupportsSecureConnection = true, PerformSubstitution = true)]
[assembly: WebResource(Constants.SliderName + Constants.JsPostfix, "text/javascript", CdnPath = Constants.CdnScriptReleasePrefix + Constants.SliderName + Constants.JsPostfix, CdnSupportsSecureConnection = true, PerformSubstitution = true)]
[assembly: WebResource(Constants.StyleResourcePrefix + Constants.SliderName + Constants.CssPostfix, "text/css", PerformSubstitution = true)]
[assembly: WebResource(Constants.StyleResourcePrefix + Constants.SliderName + Constants.MinCssPostfix, "text/css", PerformSubstitution = true)]
[assembly: WebResource(Constants.ImageResourcePrefix + Constants.SliderHorizontalHandleImage, "image/gif")]
[assembly: WebResource(Constants.ImageResourcePrefix + Constants.SliderVerticalHandleImage, "image/gif")]
[assembly: WebResource(Constants.ImageResourcePrefix + Constants.SliderHorizontalRailImage, "image/gif")]
[assembly: WebResource(Constants.ImageResourcePrefix + Constants.SliderVerticalRailImage, "image/gif")]

[assembly: WebResource(Constants.SlideShowName + Constants.DebugJsPostfix, "text/javascript", CdnPath = Constants.CdnScriptDebugPrefix + Constants.SlideShowName + Constants.DebugJsPostfix, CdnSupportsSecureConnection = true)]
[assembly: WebResource(Constants.SlideShowName + Constants.JsPostfix, "text/javascript", CdnPath = Constants.CdnScriptReleasePrefix + Constants.SlideShowName + Constants.JsPostfix, CdnSupportsSecureConnection = true)]
[assembly: WebResource(Constants.StyleResourcePrefix + Constants.SlideShowName + Constants.CssPostfix, "text/css")]
[assembly: WebResource(Constants.StyleResourcePrefix + Constants.SlideShowName + Constants.MinCssPostfix, "text/css")]

[assembly: WebResource(Constants.TabsName + Constants.DebugJsPostfix, "text/javascript", CdnPath = Constants.CdnScriptDebugPrefix + Constants.TabsName + Constants.DebugJsPostfix, CdnSupportsSecureConnection = true)]
[assembly: WebResource(Constants.TabsName + Constants.JsPostfix, "text/javascript", CdnPath = Constants.CdnScriptReleasePrefix + Constants.TabsName + Constants.JsPostfix, CdnSupportsSecureConnection = true)]
[assembly: WebResource(Constants.StyleResourcePrefix + Constants.TabsName + Constants.CssPostfix, "text/css", PerformSubstitution = true)]
[assembly: WebResource(Constants.StyleResourcePrefix + Constants.TabsName + Constants.MinCssPostfix, "text/css", PerformSubstitution = true)]
[assembly: WebResource(Constants.ImageResourcePrefix + Constants.TabsImage, "image/gif")]
[assembly: WebResource(Constants.ImageResourcePrefix + Constants.TabsActiveImage, "image/gif")]
[assembly: WebResource(Constants.ImageResourcePrefix + Constants.TabsActiveLeftImage, "image/gif")]
[assembly: WebResource(Constants.ImageResourcePrefix + Constants.TabsActiveLeftVerticalleftImage, "image/gif")]
[assembly: WebResource(Constants.ImageResourcePrefix + Constants.TabsActiveLeftVerticalrightImage, "image/gif")]
[assembly: WebResource(Constants.ImageResourcePrefix + Constants.TabsActiveRightImage, "image/gif")]
[assembly: WebResource(Constants.ImageResourcePrefix + Constants.TabsActiveRightVerticallefImage, "image/gif")]
[assembly: WebResource(Constants.ImageResourcePrefix + Constants.TabsActiveRightVerticalrightImage, "image/gif")]
[assembly: WebResource(Constants.ImageResourcePrefix + Constants.TabsActiveVerticalleftImage, "image/gif")]
[assembly: WebResource(Constants.ImageResourcePrefix + Constants.TabsActiveVerticalrightImage, "image/gif")]
[assembly: WebResource(Constants.ImageResourcePrefix + Constants.TabsBottomActiveImage, "image/gif")]
[assembly: WebResource(Constants.ImageResourcePrefix + Constants.TabsBottomActiveLeftImage, "image/gif")]
[assembly: WebResource(Constants.ImageResourcePrefix + Constants.TabsBottomActiveRightImage, "image/gif")]
[assembly: WebResource(Constants.ImageResourcePrefix + Constants.TabsBottomHoverImage, "image/gif")]
[assembly: WebResource(Constants.ImageResourcePrefix + Constants.TabsBottomHoverLeftImage, "image/gif")]
[assembly: WebResource(Constants.ImageResourcePrefix + Constants.TabsBottomHoverRightImage, "image/gif")]
[assembly: WebResource(Constants.ImageResourcePrefix + Constants.TabsBottomImage, "image/gif")]
[assembly: WebResource(Constants.ImageResourcePrefix + Constants.TabsBottomLeftImage, "image/gif")]
[assembly: WebResource(Constants.ImageResourcePrefix + Constants.TabsBottomRightImage, "image/gif")]
[assembly: WebResource(Constants.ImageResourcePrefix + Constants.TabsHoverImage, "image/gif")]
[assembly: WebResource(Constants.ImageResourcePrefix + Constants.TabsHoverLeftImage, "image/gif")]
[assembly: WebResource(Constants.ImageResourcePrefix + Constants.TabsHoverLeftVerticalleftImage, "image/gif")]
[assembly: WebResource(Constants.ImageResourcePrefix + Constants.TabsHoverLeftVerticalrightImage, "image/gif")]
[assembly: WebResource(Constants.ImageResourcePrefix + Constants.TabsHoverRightImage, "image/gif")]
[assembly: WebResource(Constants.ImageResourcePrefix + Constants.TabsHoverRightVerticalleftImage, "image/gif")]
[assembly: WebResource(Constants.ImageResourcePrefix + Constants.TabsHoverRightVerticalrightImage, "image/gif")]
[assembly: WebResource(Constants.ImageResourcePrefix + Constants.TabsHoverVerticalleftImage, "image/gif")]
[assembly: WebResource(Constants.ImageResourcePrefix + Constants.TabsHoverVerticalrightImage, "image/gif")]
[assembly: WebResource(Constants.ImageResourcePrefix + Constants.TabsImage, "image/gif")]
[assembly: WebResource(Constants.ImageResourcePrefix + Constants.TabsLeftImage, "image/gif")]
[assembly: WebResource(Constants.ImageResourcePrefix + Constants.TabsLeftVerticalleftImage, "image/gif")]
[assembly: WebResource(Constants.ImageResourcePrefix + Constants.TabsLeftVerticalrightImage, "image/gif")]
[assembly: WebResource(Constants.ImageResourcePrefix + Constants.TabsLineImage, "image/gif")]
[assembly: WebResource(Constants.ImageResourcePrefix + Constants.TabsRightImage, "image/gif")]
[assembly: WebResource(Constants.ImageResourcePrefix + Constants.TabsRightVerticalleftImage, "image/gif")]
[assembly: WebResource(Constants.ImageResourcePrefix + Constants.TabsRightVerticalrightImage, "image/gif")]
[assembly: WebResource(Constants.ImageResourcePrefix + Constants.TabsVerticalleftImage, "image/gif")]
[assembly: WebResource(Constants.ImageResourcePrefix + Constants.TabsVerticalrightImage, "image/gif")]

[assembly: WebResource(Constants.TextBoxWatermarkName + Constants.DebugJsPostfix, "text/javascript", CdnPath = Constants.CdnScriptDebugPrefix + Constants.TextBoxWatermarkName + Constants.DebugJsPostfix, CdnSupportsSecureConnection = true)]
[assembly: WebResource(Constants.TextBoxWatermarkName + Constants.JsPostfix, "text/javascript", CdnPath = Constants.CdnScriptReleasePrefix + Constants.TextBoxWatermarkName + Constants.JsPostfix, CdnSupportsSecureConnection = true)]

[assembly: WebResource(Constants.ThreadingScriptName + Constants.DebugJsPostfix, "text/javascript", CdnPath = Constants.CdnScriptDebugPrefix + Constants.ThreadingScriptName + Constants.DebugJsPostfix, CdnSupportsSecureConnection = true)]
[assembly: WebResource(Constants.ThreadingScriptName + Constants.JsPostfix, "text/javascript", CdnPath = Constants.CdnScriptReleasePrefix + Constants.ThreadingScriptName + Constants.JsPostfix, CdnSupportsSecureConnection = true)]

[assembly: WebResource(Constants.ToggleButtonName + Constants.DebugJsPostfix, "text/javascript", CdnPath = Constants.CdnScriptDebugPrefix + Constants.ToggleButtonName + Constants.DebugJsPostfix, CdnSupportsSecureConnection = true)]
[assembly: WebResource(Constants.ToggleButtonName + Constants.JsPostfix, "text/javascript", CdnPath = Constants.CdnScriptReleasePrefix + Constants.ToggleButtonName + Constants.JsPostfix, CdnSupportsSecureConnection = true)]

[assembly: WebResource(Constants.StyleResourcePrefix + Constants.TwitterName + Constants.CssPostfix, "text/css", PerformSubstitution = true)]
[assembly: WebResource(Constants.StyleResourcePrefix + Constants.TwitterName + Constants.MinCssPostfix, "text/css", PerformSubstitution = true)]
[assembly: WebResource(Constants.ImageResourcePrefix + Constants.Twitter24Image, "image/png")]
[assembly: WebResource(Constants.ImageResourcePrefix + Constants.Twitter32Image, "image/png")]

[assembly: WebResource(Constants.UpdatePanelAnimationName + Constants.DebugJsPostfix, "text/javascript", CdnPath = Constants.CdnScriptDebugPrefix + Constants.UpdatePanelAnimationName + Constants.DebugJsPostfix, CdnSupportsSecureConnection = true)]
[assembly: WebResource(Constants.UpdatePanelAnimationName + Constants.JsPostfix, "text/javascript", CdnPath = Constants.CdnScriptReleasePrefix + Constants.UpdatePanelAnimationName + Constants.JsPostfix, CdnSupportsSecureConnection = true)]

[assembly: WebResource(Constants.ValidatorCalloutName + Constants.DebugJsPostfix, "text/javascript", CdnPath = Constants.CdnScriptDebugPrefix + Constants.ValidatorCalloutName + Constants.DebugJsPostfix, CdnSupportsSecureConnection = true)]
[assembly: WebResource(Constants.ValidatorCalloutName + Constants.JsPostfix, "text/javascript", CdnPath = Constants.CdnScriptReleasePrefix + Constants.ValidatorCalloutName + Constants.JsPostfix, CdnSupportsSecureConnection = true)]
[assembly: WebResource(Constants.StyleResourcePrefix + Constants.ValidatorCalloutName + Constants.CssPostfix, "text/css", PerformSubstitution = true)]
[assembly: WebResource(Constants.StyleResourcePrefix + Constants.ValidatorCalloutName + Constants.MinCssPostfix, "text/css", PerformSubstitution = true)]
[assembly: WebResource(Constants.ImageResourcePrefix + Constants.ValidatorCalloutAlertLargeImage, "image/gif")]
[assembly: WebResource(Constants.ImageResourcePrefix + Constants.ValidatorCalloutAlertSmallImage, "image/gif")]
[assembly: WebResource(Constants.ImageResourcePrefix + Constants.ValidatorCalloutCloseImage, "image/gif")]

[assembly: WebResource(Constants.LocalizationScriptName + Constants.JsPostfix, "text/javascript", CdnPath = Constants.CdnScriptReleasePrefix + Constants.LocalizationScriptName + Constants.JsPostfix, CdnSupportsSecureConnection = true)]
[assembly: WebResource(Constants.LocalizationScriptName + Constants.DebugJsPostfix, "text/javascript", CdnPath = Constants.CdnScriptDebugPrefix + Constants.LocalizationScriptName + Constants.DebugJsPostfix, CdnSupportsSecureConnection = true)]

[assembly: WebResource(Constants.LocalizationScriptName + ".ar" + Constants.JsPostfix, "text/javascript", CdnPath = Constants.CdnScriptReleasePrefix + Constants.LocalizationScriptName + ".ar" + Constants.JsPostfix, CdnSupportsSecureConnection = true)]
[assembly: WebResource(Constants.LocalizationScriptName + ".ar" + Constants.DebugJsPostfix, "text/javascript", CdnPath = Constants.CdnScriptDebugPrefix + Constants.LocalizationScriptName + ".ar" + Constants.DebugJsPostfix, CdnSupportsSecureConnection = true)]

[assembly: WebResource(Constants.LocalizationScriptName + ".cs" + Constants.JsPostfix, "text/javascript", CdnPath = Constants.CdnScriptReleasePrefix + Constants.LocalizationScriptName + ".cs" + Constants.JsPostfix, CdnSupportsSecureConnection = true)]
[assembly: WebResource(Constants.LocalizationScriptName + ".cs" + Constants.DebugJsPostfix, "text/javascript", CdnPath = Constants.CdnScriptDebugPrefix + Constants.LocalizationScriptName + ".cs" + Constants.DebugJsPostfix, CdnSupportsSecureConnection = true)]

[assembly: WebResource(Constants.LocalizationScriptName + ".de" + Constants.JsPostfix, "text/javascript", CdnPath = Constants.CdnScriptReleasePrefix + Constants.LocalizationScriptName + ".de" + Constants.JsPostfix, CdnSupportsSecureConnection = true)]
[assembly: WebResource(Constants.LocalizationScriptName + ".de" + Constants.DebugJsPostfix, "text/javascript", CdnPath = Constants.CdnScriptDebugPrefix + Constants.LocalizationScriptName + ".de" + Constants.DebugJsPostfix, CdnSupportsSecureConnection = true)]

[assembly: WebResource(Constants.LocalizationScriptName + ".es" + Constants.JsPostfix, "text/javascript", CdnPath = Constants.CdnScriptReleasePrefix + Constants.LocalizationScriptName + ".es" + Constants.JsPostfix, CdnSupportsSecureConnection = true)]
[assembly: WebResource(Constants.LocalizationScriptName + ".es" + Constants.DebugJsPostfix, "text/javascript", CdnPath = Constants.CdnScriptDebugPrefix + Constants.LocalizationScriptName + ".es" + Constants.DebugJsPostfix, CdnSupportsSecureConnection = true)]

[assembly: WebResource(Constants.LocalizationScriptName + ".fr" + Constants.JsPostfix, "text/javascript", CdnPath = Constants.CdnScriptReleasePrefix + Constants.LocalizationScriptName + ".fr" + Constants.JsPostfix, CdnSupportsSecureConnection = true)]
[assembly: WebResource(Constants.LocalizationScriptName + ".fr" + Constants.DebugJsPostfix, "text/javascript", CdnPath = Constants.CdnScriptDebugPrefix + Constants.LocalizationScriptName + ".fr" + Constants.DebugJsPostfix, CdnSupportsSecureConnection = true)]

[assembly: WebResource(Constants.LocalizationScriptName + ".he" + Constants.JsPostfix, "text/javascript", CdnPath = Constants.CdnScriptReleasePrefix + Constants.LocalizationScriptName + ".he" + Constants.JsPostfix, CdnSupportsSecureConnection = true)]
[assembly: WebResource(Constants.LocalizationScriptName + ".he" + Constants.DebugJsPostfix, "text/javascript", CdnPath = Constants.CdnScriptDebugPrefix + Constants.LocalizationScriptName + ".he" + Constants.DebugJsPostfix, CdnSupportsSecureConnection = true)]

[assembly: WebResource(Constants.LocalizationScriptName + ".hi" + Constants.JsPostfix, "text/javascript", CdnPath = Constants.CdnScriptReleasePrefix + Constants.LocalizationScriptName + ".hi" + Constants.JsPostfix, CdnSupportsSecureConnection = true)]
[assembly: WebResource(Constants.LocalizationScriptName + ".hi" + Constants.DebugJsPostfix, "text/javascript", CdnPath = Constants.CdnScriptDebugPrefix + Constants.LocalizationScriptName + ".hi" + Constants.DebugJsPostfix, CdnSupportsSecureConnection = true)]

[assembly: WebResource(Constants.LocalizationScriptName + ".it" + Constants.JsPostfix, "text/javascript", CdnPath = Constants.CdnScriptReleasePrefix + Constants.LocalizationScriptName + ".it" + Constants.JsPostfix, CdnSupportsSecureConnection = true)]
[assembly: WebResource(Constants.LocalizationScriptName + ".it" + Constants.DebugJsPostfix, "text/javascript", CdnPath = Constants.CdnScriptDebugPrefix + Constants.LocalizationScriptName + ".it" + Constants.DebugJsPostfix, CdnSupportsSecureConnection = true)]

[assembly: WebResource(Constants.LocalizationScriptName + ".ja" + Constants.JsPostfix, "text/javascript", CdnPath = Constants.CdnScriptReleasePrefix + Constants.LocalizationScriptName + ".ja" + Constants.JsPostfix, CdnSupportsSecureConnection = true)]
[assembly: WebResource(Constants.LocalizationScriptName + ".ja" + Constants.DebugJsPostfix, "text/javascript", CdnPath = Constants.CdnScriptDebugPrefix + Constants.LocalizationScriptName + ".ja" + Constants.DebugJsPostfix, CdnSupportsSecureConnection = true)]

[assembly: WebResource(Constants.LocalizationScriptName + ".ko" + Constants.JsPostfix, "text/javascript", CdnPath = Constants.CdnScriptReleasePrefix + Constants.LocalizationScriptName + ".ko" + Constants.JsPostfix, CdnSupportsSecureConnection = true)]
[assembly: WebResource(Constants.LocalizationScriptName + ".ko" + Constants.DebugJsPostfix, "text/javascript", CdnPath = Constants.CdnScriptDebugPrefix + Constants.LocalizationScriptName + ".ko" + Constants.DebugJsPostfix, CdnSupportsSecureConnection = true)]

[assembly: WebResource(Constants.LocalizationScriptName + ".nl" + Constants.JsPostfix, "text/javascript", CdnPath = Constants.CdnScriptReleasePrefix + Constants.LocalizationScriptName + ".nl" + Constants.JsPostfix, CdnSupportsSecureConnection = true)]
[assembly: WebResource(Constants.LocalizationScriptName + ".nl" + Constants.DebugJsPostfix, "text/javascript", CdnPath = Constants.CdnScriptDebugPrefix + Constants.LocalizationScriptName + ".nl" + Constants.DebugJsPostfix, CdnSupportsSecureConnection = true)]

[assembly: WebResource(Constants.LocalizationScriptName + ".pl" + Constants.JsPostfix, "text/javascript", CdnPath = Constants.CdnScriptReleasePrefix + Constants.LocalizationScriptName + ".pl" + Constants.JsPostfix, CdnSupportsSecureConnection = true)]
[assembly: WebResource(Constants.LocalizationScriptName + ".pl" + Constants.DebugJsPostfix, "text/javascript", CdnPath = Constants.CdnScriptDebugPrefix + Constants.LocalizationScriptName + ".pl" + Constants.DebugJsPostfix, CdnSupportsSecureConnection = true)]

[assembly: WebResource(Constants.LocalizationScriptName + ".pt" + Constants.JsPostfix, "text/javascript", CdnPath = Constants.CdnScriptReleasePrefix + Constants.LocalizationScriptName + ".pt" + Constants.JsPostfix, CdnSupportsSecureConnection = true)]
[assembly: WebResource(Constants.LocalizationScriptName + ".pt" + Constants.DebugJsPostfix, "text/javascript", CdnPath = Constants.CdnScriptDebugPrefix + Constants.LocalizationScriptName + ".pt" + Constants.DebugJsPostfix, CdnSupportsSecureConnection = true)]

[assembly: WebResource(Constants.LocalizationScriptName + ".ru" + Constants.JsPostfix, "text/javascript", CdnPath = Constants.CdnScriptReleasePrefix + Constants.LocalizationScriptName + ".ru" + Constants.JsPostfix, CdnSupportsSecureConnection = true)]
[assembly: WebResource(Constants.LocalizationScriptName + ".ru" + Constants.DebugJsPostfix, "text/javascript", CdnPath = Constants.CdnScriptDebugPrefix + Constants.LocalizationScriptName + ".ru" + Constants.DebugJsPostfix, CdnSupportsSecureConnection = true)]

[assembly: WebResource(Constants.LocalizationScriptName + ".tr" + Constants.JsPostfix, "text/javascript", CdnPath = Constants.CdnScriptReleasePrefix + Constants.LocalizationScriptName + ".tr" + Constants.JsPostfix, CdnSupportsSecureConnection = true)]
[assembly: WebResource(Constants.LocalizationScriptName + ".tr" + Constants.DebugJsPostfix, "text/javascript", CdnPath = Constants.CdnScriptDebugPrefix + Constants.LocalizationScriptName + ".tr" + Constants.DebugJsPostfix, CdnSupportsSecureConnection = true)]

[assembly: WebResource(Constants.LocalizationScriptName + ".zh-CHS" + Constants.JsPostfix, "text/javascript", CdnPath = Constants.CdnScriptReleasePrefix + Constants.LocalizationScriptName + ".zh-CHS" + Constants.JsPostfix, CdnSupportsSecureConnection = true)]
[assembly: WebResource(Constants.LocalizationScriptName + ".zh-CHS" + Constants.DebugJsPostfix, "text/javascript", CdnPath = Constants.CdnScriptDebugPrefix + Constants.LocalizationScriptName + ".zh-CHS" + Constants.DebugJsPostfix, CdnSupportsSecureConnection = true)]

[assembly: WebResource(Constants.LocalizationScriptName + ".zh-CHT" + Constants.JsPostfix, "text/javascript", CdnPath = Constants.CdnScriptReleasePrefix + Constants.LocalizationScriptName + ".zh-CHT" + Constants.JsPostfix, CdnSupportsSecureConnection = true)]
[assembly: WebResource(Constants.LocalizationScriptName + ".zh-CHT" + Constants.DebugJsPostfix, "text/javascript", CdnPath = Constants.CdnScriptDebugPrefix + Constants.LocalizationScriptName + ".zh-CHT" + Constants.DebugJsPostfix, CdnSupportsSecureConnection = true)]