# Contributing to the Repository
## Bugs & Feature Requests

**If you found a security vulnerability, please send info about it to info@devexpress.com**

Please report bugs and feature requests to the project's [issue tracker](https://github.com/DevExpress/AjaxControlToolkit/issues).  
For bugs, send a sample project which we can debug on our side. Attach it as a ZIP file or provide a GitHub link.

If it is not possible, please describe in detail:
* Minimal steps to reproduce the bug.
* The AJAX Control Toolkit version you are using.
* The installation method (installer, NuGet package or a custom build from the source code)

In both cases, provide the following info:
* An expected result.
* An actual result.
* A browser(s) you are using.
* A site deploy method (VS development web-server, IIS).

## Pull requests

Feel free to contribute to this project by [forking](http://help.github.com/fork-a-repo/) this repository and making changes to the fork. Once you have made your changes, share them with the community by sending a [pull request](http://help.github.com/send-pull-requests/) to the **master** branch.

## Pull request requirements
* Tests are welcome: 

 Unit tests project: [AjaxControlToolkit.Tests](https://github.com/DevExpress/AjaxControlToolkit/tree/master/AjaxControlToolkit.Tests).

 Functional tests project: [AjaxControlToolkit.Jasmine](https://github.com/DevExpress/AjaxControlToolkit/tree/master/AjaxControlToolkit.Jasmine).

* Pull request must not break any existing tests.

* Pull request must not change the formatting of the existing code not related to the pull request.
