# AJAX Control Toolkit (maintained by [DevExpress](https://go.devexpress.com/AjaxControlToolkit_GitHub_DevExpressHome.aspx))
[![Build status](https://ci.appveyor.com/api/projects/status/7ad3rsrupu40mx1r/branch/master?svg=true)](https://ci.appveyor.com/project/dxrobot/ajaxcontroltoolkit/branch/master)
[![Installer](https://img.shields.io/badge/get%20installer-20.1.0-orange.svg)](https://go.devexpress.com/AjaxControlToolkit_Website_Download.aspx)

The ASP.NET AJAX Control Toolkit contains a rich set of controls that you can use to build highly responsive and interactive AJAX-enabled Web applications. AjaxControlToolkit contains more than 40 controls, including the AutoComplete, CollapsiblePanel, ColorPicker, MaskedEdit, Calendar, Accordion, and Watermark controls. Using AjaxControlToolkit, you can build AJAX-enabled ASP.NET Web Forms applications by dragging-and-dropping Toolkit controls from the Visual Studio Toolbox onto a Web Forms page.

**v20.1.0 is now available**! [Get the new installer from DevExpress.com](https://go.devexpress.com/AjaxControlToolkit_GitHub_DevExpressPage.aspx).

![logo](https://github.com/DevExpress/AjaxControlToolkit/raw/wiki-static-resources/readme-banner.png)

If you've used the toolkit in the past, you also know that for quite some time, the project was poorly supported, with an ever growing list of critical issues. Seeing the demand for such a library and considering its current state, we approached Microsoft and suggested that we help bring the Toolkit back into a dependable and usable state. Needless to say, Microsoft agreed. The good news is that since we took on this responsibility, we've managed to clean up the codebase, introduced improved Visual Studio support, and fixed nearly 900 bugs.

[Download](https://go.devexpress.com/AjaxControlToolkit_GitHub_DevExpressPage.aspx) the DevExpress Edition of the AJAX Control Toolkit today, evaluate it in your project and let us know what you think.

Watch the **Getting Started** video:

[![video](https://github.com/DevExpress/AjaxControlToolkit/raw/wiki-static-resources/youtube-getting-started.png)](https://youtu.be/24hIhS2itUU)

You can also watch this **Channel 9** Video: [DevExpress maintains AjaxControlToolkit for ASP.NET WebForms Developers](http://channel9.msdn.com/Shows/Web+Camps+TV/DevExpress-maintains-AjaxControlToolkit-for-ASPNET-WebForms-Developers)

Check out these helpful articles:

1. [Step-by-Step Installation Guide](https://github.com/DevExpress/AjaxControlToolkit/wiki/Step-by-Step-Installation-Guide)

2. [Upgrading from v7.x and below](https://github.com/DevExpress/AjaxControlToolkit/wiki/Upgrading-from-v7.x-and-below)

3. [How to use bundling and CDN](https://github.com/DevExpress/AjaxControlToolkit/wiki/How-to-use-bundling-and-CDN)

4. [Online demos](http://ajaxcontroltoolkit.devexpress.com/)
